#include "mxcl.h"
#include "mxcl_id.h"


Boolean quit=False;



/* local prototypes */

extern Boolean MainHandleEvent(EventPtr);
extern void EventLoop(void);
extern void InitializeApp(void);
extern void CloseFormMain(void);
extern void CloseApp(void);
extern UInt32 PilotMain(UInt16, void*, UInt16);


void QuitApp(void)
{
    quit=True;
}



/* event loop */

Boolean MainHandleEvent(EventPtr e)
{
    Boolean ret = False;
    FormPtr frm;
    UInt16  formID;

    switch(e->eType){
      case frmLoadEvent:
        formID=e->data.frmLoad.formID;
        frm=FrmInitForm(formID);
        switch(formID){
          case ID_FORM_STD:
          case ID_FORM_EXP:
            OpenFormMain(frm);
            break;
          case ID_FORM_UNIT_LIST:
            OpenFormUnitList(frm);
            break;
        }
        FrmSetActiveForm(frm);
        FrmDrawForm(frm);
        ret=True;
        break;
/*      case appStopEvent:
        QuitApp();
        ret=True;
        break;*/
      default:
    }
    return ret;
}

void EventLoop(void)
{
    EventType event;
    UInt16 err;

    do{
        EvtGetEvent(&event, evtWaitForever);
        if(! SysHandleEvent(&event)){
            if(! MenuHandleEvent(NULL, &event, &err)){
                if(! MainHandleEvent(&event))
                        FrmDispatchEvent(&event);
            }
        }
    }while(!quit);
}



/* initialize */

void InitializeApp(void)
{
    GetPrefs();
    GetStatus();
    SetOperatorsFunc();
    OpenMathLib();

    FrmGotoForm(PrefCurrentForm());
}

/* close */

void CloseFormMain(void)
{
    CloseUnitDB();
//    FrmDeleteForm(FrmGetFormPtr(pref.id_form));
}

void CloseApp(void)
{
    CloseFormMain();
    SaveStatus();
    SavePrefs();
    CloseMathLib();
}



/* main */

UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 launchFlags)
{
    switch(cmd){
      case sysAppLaunchCmdNormalLaunch:
        InitializeApp();
        EventLoop();
        break;
      default:
    }
    if(cmd==sysAppLaunchCmdNormalLaunch) CloseApp();
    return(0);
}
