#include "mxcl.h"
#include "mxcl_id.h"


/* local prototypes */

extern void SetFieldTextHandle(UInt16, MemHandle);
extern void SetFieldTextString(UInt16, Char*);
extern void GetFieldTextString(UInt16, Char*);
extern Boolean UnitSystemPropModal(UnitStruct*);
extern Boolean UnitPropModal(UnitStruct*);
extern UInt16 GetSelectedULUnit(void);
extern UInt16 GetSelectedULUnitSystem(void);
extern void DrawULUnitList(Int16, RectangleType*, Char**);
extern void DrawULUnitSystemList(Int16, RectangleType*, Char**);
extern void SetULUnitList(UInt16);
extern void AddUnitSystem(void);
extern void EditUnitSystem(void);
extern void DeleteUnitSystem(void);
extern void UpUnitSystem(void);
extern void DownUnitSystem(void);
extern void AddUnit(void);
extern void EditUnit(void);
extern void DeleteUnit(void);
extern void UpUnit(void);
extern void DownUnit(void);
extern Boolean FormULButtonHandling(UInt16);
extern Boolean FormULListHandling(EventPtr);
extern Boolean FormUnitListHandleEvent(EventPtr);




/* util for Fields */

void SetFieldTextHandle(UInt16 fID, MemHandle txth)
{
    MemHandle oldh;
    FormPtr frm=FrmGetActiveForm();
    FieldPtr fp;

    fp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, fID));
    if(!fp){
        FrmCustomAlert(ID_DEBUGALERT, "no Field", "", "");
        return;
    }
    oldh=FldGetTextHandle(fp);
    FldSetTextHandle(fp, txth);
    FldDrawField(fp);
    if(oldh) MemHandleFree(oldh);
}

void SetFieldTextString(UInt16 fID, Char* str)
{
    MemHandle txth;

    txth=MemHandleNew(StrLen(str)+1);
    if(!txth){
        FrmCustomAlert(ID_DEBUGALERT, "no Handle", "", "");
        return;
    }
    StrCopy(MemHandleLock(txth), str);
    MemHandleUnlock(txth);

    SetFieldTextHandle(fID, txth);
}

void GetFieldTextString(UInt16 fID, Char* str)
{
    MemHandle txth;
    FormPtr frm=FrmGetActiveForm();
    FieldPtr fp;

    fp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, fID));
    if(!fp){
        FrmCustomAlert(ID_DEBUGALERT, "no Field", "", "");
        return;
    }
    txth=FldGetTextHandle(fp);
    StrCopy(str, MemHandleLock(txth));
    MemHandleUnlock(txth);
}


/*void FreeField(UInt16 frID, UInt16 fldID)
{
    MemHandle txth;
    FormPtr frm=FrmGetFormPtr(frID);
    FieldPtr fp;

    fp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, fldID));
    txth=FldGetTextHandle(fp);
    if(txth) MemHandleFree(txth);
}*/

/*void FreeFieldULModal(void)
{
    FreeField(ID_FORM_UN_PROP, ID_UNP_FIELD_NAME);
    FreeField(ID_FORM_UN_PROP, ID_UNP_FIELD_SIGN);
    FreeField(ID_FORM_UN_PROP, ID_UNP_FIELD_RATE);
}*/

/* functions for modals */

Boolean UnitSystemPropModal(UnitStruct* ust)
{
    Boolean ret=False;
    UInt16 bID;
    FormPtr pfrm=FrmGetActiveForm();
    FormPtr frm=FrmInitForm(ID_FORM_US_PROP);

    FrmSetActiveForm(frm);

    SetFieldTextString(ID_USP_FIELD_NAME, ust->name);

    bID=FrmDoDialog(frm);
    if(bID==ID_USP_BTN_OK){
        GetFieldTextString(ID_USP_FIELD_NAME, ust->name);
        ret=True;
    }
    if(pfrm) FrmSetActiveForm(pfrm);
//    FreeFieldULModal();
    FrmDeleteForm(frm);
    FrmDrawForm(pfrm);
    return ret;
}

Boolean UnitPropModal(UnitStruct* ust)
{
    Boolean ret=False;
    UInt16 bID;
    FlpCompDouble v;
    Char str[MAX_CHAR];
    FormPtr pfrm=FrmGetActiveForm();
    FormPtr frm=FrmInitForm(ID_FORM_UN_PROP);
    RoundType rd;

    FrmSetActiveForm(frm);

    SetFieldTextString(ID_UNP_FIELD_NAME, ust->name);
    SetFieldTextString(ID_UNP_FIELD_SIGN, ust->sign);
    v.d=ust->rate;
    rd.type=RD_NONE;
    ValFloatToStr(rd, v, str);
    SetFieldTextString(ID_UNP_FIELD_RATE, str);

    bID=FrmDoDialog(frm);
    if(bID==ID_UNP_BTN_OK){
        GetFieldTextString(ID_UNP_FIELD_NAME, ust->name);
        GetFieldTextString(ID_UNP_FIELD_SIGN, ust->sign);
        GetFieldTextString(ID_UNP_FIELD_RATE, str);
        FlpBufferAToF(&(v.fd), str);
        ust->rate=v.d;
        ret=True;
    }
    if(pfrm) FrmSetActiveForm(pfrm);
//    FreeFieldULModal();
    FrmDeleteForm(frm);
    FrmDrawForm(pfrm);
    return ret;
}

/* util for lists */

UInt16 GetSelectedULUnit(void)
{
    Int16 ret;
    FormPtr frm;
    ListPtr lp;

    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));

    ret=LstGetSelection(lp)+1;
    if(ret<1) ret=1;
    return ret;
}

UInt16 GetSelectedULUnitSystem(void)
{
    Int16 ret;
    FormPtr frm;
    ListPtr lp;

    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));

    ret=LstGetSelection(lp)+1;
    if(ret<1) ret=1;
    return ret;
}

void DrawULUnitList(Int16 num,
                    RectangleType* rect,
                    Char** texts)
{
    UInt16 usys;
    Char str[MAX_CHAR];
    UnitStruct ust;
    FlpCompDouble v;
    Coord x=rect->topLeft.x;
    RoundType rd;

    CALLBACK_PROLOGUE

    InitializeUnitStruct(&ust);
    usys=GetSelectedULUnitSystem();
//    GetUnitName(usys, num+1, str+4);
    GetUnitStruct(usys, num+1, &ust);
//    StrPrintF(str, "%2d:", num+1);
    StrPrintF(str, "%2d:", ust.unit);
    WinDrawChars(str, StrLen(str), x, rect->topLeft.y);
    x+=UL_NUM_W;
//    WinDrawChars(ust.sign, StrLen(ust.sign), x, rect->topLeft.y);
//    x+=UL_SIGN_W;
    if(ust.name[0]=='\0'){
        StrCopy(str, "(none)");
    }else{
        StrCopy(str, ust.name);
    }
    WinDrawChars(str, StrLen(str), x, rect->topLeft.y);
    x+=UL_NAME_W;
    v.d=ust.rate;
    rd.type=RD_NONE;
    ValFloatToStr(rd, v, str);
    WinDrawChars(str, StrLen(str), x, rect->topLeft.y);
    CALLBACK_EPILOGUE
}

void DrawULUnitSystemList(Int16 num,
                        RectangleType* rect,
                        Char** texts)
{
    Char str[MAX_NAME_CHAR+4];
    Coord x=rect->topLeft.x;

    CALLBACK_PROLOGUE

    StrPrintF(str, "%2d:", num+1);
    WinDrawChars(str, StrLen(str), x, rect->topLeft.y);
    x+=UL_NUM_W;
    GetUnitName(0, num+1, str);
    if(str[0]=='\0') StrCopy(str, "(none)");
    WinDrawChars(str, StrLen(str), x, rect->topLeft.y);

    CALLBACK_EPILOGUE
}

void SetULUnitList(UInt16 usys)
{
    UInt16 num;
    FormPtr frm;
    ListPtr lp;
    ListDrawDataFuncPtr drawF;

    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);

    if(usys){
//        usys=GetSelectedUnitSystem();
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
        drawF=(ListDrawDataFuncPtr)DrawULUnitList;
    }else{
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));
        drawF=(ListDrawDataFuncPtr)DrawULUnitSystemList;
    }
    num=GetUnitSystemNum(usys);
    LstSetListChoices(lp, NULL, num);
    LstSetDrawFunction(lp, drawF);
//    if(MAX_LIST+2<num) num=MAX_LIST;
//    LstSetHeight(lp, num);
    LstSetSelection(lp, 0);
    if(!usys) SetULUnitList(1);
}


/* functions for edit Unit Struct */

void AddUnitSystem(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    InitializeUnitStruct(&ust);
    if(!UnitSystemPropModal(&ust)) return;
    ust.usys=0;
    ust.unit=GetSelectedULUnitSystem()+1;
    AddUnitSystemStruct(&ust);
    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));
    LstSetListChoices(lp, NULL, LstGetNumberOfItems(lp)+1);
    LstSetSelection(lp, ust.unit-1);
    LstDrawList(lp);
    SetULUnitList(ust.unit);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
    LstDrawList(lp);
}

void EditUnitSystem(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

//    InitializeUnitStruct(&ust);
    ust.usys=0;
    ust.unit=GetSelectedULUnitSystem();
    GetUnitStruct(ust.usys, ust.unit, &ust);
    if(!UnitSystemPropModal(&ust)) return;
    SaveUnitStruct(&ust);
    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));
    LstDrawList(lp);
}

void DeleteUnitSystem(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    ust.usys=0;
    ust.unit=GetSelectedULUnitSystem();
    if(DeleteUnitSystemStruct(&ust)){
        frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));
        LstSetListChoices(lp, NULL, GetUnitSystemNum(0));
        LstDrawList(lp);
        SetULUnitList(GetSelectedULUnitSystem());
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
        LstDrawList(lp);
    }
}

void UpUnitSystem(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    ust.usys=0;
    ust.unit=GetSelectedULUnitSystem();
    if(ust.unit<=1) return;
    ust.unit--;
    if(DownUnitSystemStruct(&ust)){
        frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));
        LstSetSelection(lp, ust.unit-1);
        LstDrawList(lp);
        SetULUnitList(GetSelectedULUnitSystem());
//        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
//        LstDrawList(lp);
    }
}

void DownUnitSystem(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    ust.usys=0;
    ust.unit=GetSelectedULUnitSystem();
    if(DownUnitSystemStruct(&ust)){
        frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_USYS));
        LstSetSelection(lp, ust.unit);
        LstDrawList(lp);
        SetULUnitList(GetSelectedULUnitSystem());
//        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
//        LstDrawList(lp);
    }
}

/* functions for edit Unit */

void AddUnit(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    InitializeUnitStruct(&ust);
    if(!UnitPropModal(&ust)) return;
    ust.usys=GetSelectedULUnitSystem();
    ust.unit=GetSelectedULUnit()+1;
    AddUnitStruct(&ust);
    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
    LstSetListChoices(lp, NULL, LstGetNumberOfItems(lp)+1);
    LstSetSelection(lp, LstGetSelection(lp)+1);
    LstDrawList(lp);
}

void EditUnit(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

//    InitializeUnitStruct(&ust);
    ust.usys=GetSelectedULUnitSystem();
    ust.unit=GetSelectedULUnit();
    GetUnitStruct(ust.usys, ust.unit, &ust);
    if(!UnitPropModal(&ust)) return;
    SaveUnitStruct(&ust);
    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
    LstDrawList(lp);
}

void DeleteUnit(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    ust.usys=GetSelectedULUnitSystem();
    ust.unit=GetSelectedULUnit();
    if(DeleteUnitStruct(&ust)){
        frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
        LstSetListChoices(lp, NULL, GetUnitSystemNum(ust.usys));
        LstDrawList(lp);
    }
}

void UpUnit(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    ust.usys=GetSelectedULUnitSystem();
    ust.unit=GetSelectedULUnit();
    if(ust.unit<=1) return;
    ust.unit--;
    if(DownUnitStruct(&ust)){
        frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
        LstSetSelection(lp, ust.unit-1);
        LstDrawList(lp);
    }
}

void DownUnit(void)
{
    UnitStruct ust;
    FormPtr frm;
    ListPtr lp;

    ust.usys=GetSelectedULUnitSystem();
    ust.unit=GetSelectedULUnit();
    if(DownUnitStruct(&ust)){
        frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT));
        LstSetSelection(lp, ust.unit);
        LstDrawList(lp);
    }
}



/* event handling */

Boolean FormULButtonHandling(UInt16 id)
{
    Boolean ret=False;

    switch(id){
      case ID_UL_US_BTN_ADD:
        AddUnitSystem();
        ret=True;
        break;
      case ID_UL_US_BTN_EDIT:
        EditUnitSystem();
        ret=True;
        break;
      case ID_UL_US_BTN_DEL:
        DeleteUnitSystem();
        ret=True;
        break;
      case ID_UL_US_BTN_UP:
        UpUnitSystem();
        ret=True;
        break;
      case ID_UL_US_BTN_DOWN:
        DownUnitSystem();
        ret=True;
        break;
      case ID_UL_UL_BTN_ADD:
        AddUnit();
        ret=True;
        break;
      case ID_UL_UL_BTN_EDIT:
        EditUnit();
        ret=True;
        break;
      case ID_UL_UL_BTN_DEL:
        DeleteUnit();
        ret=True;
        break;
      case ID_UL_UL_BTN_UP:
        UpUnit();
        ret=True;
        break;
      case ID_UL_UL_BTN_DOWN:
        DownUnit();
        ret=True;
        break;
      case ID_UL_BTN_CLOSE:
        CloseFormUnitList();
        FrmGotoForm(PrefCurrentForm());
        ret=True;
        break;
    }
    return ret;
}

Boolean FormULListHandling(EventPtr e)
{
    FormPtr frm;
    Boolean ret=True;
    Int16 num=e->data.lstSelect.selection;

    if(e->data.lstSelect.listID!=ID_UL_LIST_USYS){
        return ret;
    }
    SetULUnitList(num+1);
    frm=FrmGetFormPtr(ID_FORM_UNIT_LIST);
    LstDrawList(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_UL_LIST_UNIT)));

    return ret;
}

Boolean FormUnitListHandleEvent(EventPtr e)
{
    Boolean ret=False;

    CALLBACK_PROLOGUE

    switch(e->eType){
/*      case keyDownEvent:
        ret=KeyHandling(e->data.keyDown.chr);
        break;*/
      case ctlSelectEvent:
        ret=FormULButtonHandling(e->data.ctlSelect.controlID);
        break;
      case lstSelectEvent:
        ret=FormULListHandling(e);
        break;
/*      case menuEvent:
        ret=MenuHandling(e->data.menu.itemID);
        break;*/
      case appStopEvent:
        QuitApp();
        FormULButtonHandling(ID_UL_BTN_CLOSE);
        ret=True;
        break;
      default:
    }

    CALLBACK_EPILOGUE
    return ret;
}


/* open and close form */

void OpenFormUnitList(FormPtr frm)
{
    Err err;

    FrmSetEventHandler(frm, (FormEventHandlerType*)FormUnitListHandleEvent);
    if((err=OpenUnitDB(True))){
//        StrPrintF(debug_msg, "Cannot open unit DB. ERROR CODE: %d", err);
//        FrmCustomAlert(ID_DEBUGALERT, debug_msg, "", "");
        ErrFatalDisplayIf(err, "Cannot open unit DB.");
        QuitApp();
        return;
    }
    SetULUnitList(0);
}

void CloseFormUnitList(void)
{
    InitializeStatus();
    InitializeVariables();
    FrmEraseForm(FrmGetFormPtr(ID_FORM_UNIT_LIST));
    FrmDeleteForm(FrmGetFormPtr(ID_FORM_UNIT_LIST));
    CloseUnitDB();
}
