#include "mxcl.h"
#include "mxcl_id.h"


OperatorList opes[]=
{
    {ID_BTN_PI,    0, F_PRE,   False, NULL},
    {ID_BTN_LNE,   0, F_PRE,   False, NULL},
    {ID_BTN_RND,   0, F_PRE,   False, NULL},
    {ID_BTN_RNDN,  1, F_PRE,   False, NULL},
    {ID_BTN_FACT,  1, F_PRE,   False, NULL},
    {ID_BTN_AND,   2, F_PRE,   False, NULL},
    {ID_BTN_OR,    2, F_PRE,   False, NULL},
    {ID_BTN_NOT,   1, F_PRE,   False, NULL},
    {ID_BTN_XOR,   2, F_PRE,   False, NULL},
    {ID_BTN_LSH,   1, F_PRE,   False, NULL},
    {ID_BTN_RSH,   1, F_PRE,   False, NULL},
    {ID_BTN_INV,   1, F_LOCAL, False, NULL},
    {ID_BTN_SQ,    1, F_LOCAL, False, NULL},
    {ID_BTN_CB,    1, F_LOCAL, False, NULL},
    {ID_BTN_SQR,   1, F_PRE,   True,  NULL},
    {ID_BTN_CBR,   1, F_PRE,   True,  NULL},
    {ID_BTN_SIN,   1, F_PRE,   True,  NULL},
    {ID_BTN_COS,   1, F_PRE,   True,  NULL},
    {ID_BTN_TAN,   1, F_PRE,   True,  NULL},
    {ID_BTN_ASIN,  1, F_PRE,   True,  NULL},
    {ID_BTN_ACOS,  1, F_PRE,   True,  NULL},
    {ID_BTN_ATAN,  1, F_PRE,   True,  NULL},
    {ID_BTN_SINH,  1, F_PRE,   True,  NULL},
    {ID_BTN_COSH,  1, F_PRE,   True,  NULL},
    {ID_BTN_TANH,  1, F_PRE,   True,  NULL},
    {ID_BTN_ASINH, 1, F_PRE,   True,  NULL},
    {ID_BTN_ACOSH, 1, F_PRE,   True,  NULL},
    {ID_BTN_ATANH, 1, F_PRE,   True,  NULL},
    {ID_BTN_2X,    1, F_PRE,   True,  NULL},
    {ID_BTN_10X,   1, F_PRE,   True,  NULL},
    {ID_BTN_EXP,   1, F_PRE,   True,  NULL},
    {ID_BTN_POW,   ARG_SD, F_LOCAL, True,  NULL},
    {ID_BTN_POW_D, 2, F_PRE,   True,  NULL},
    {ID_BTN_LOG2,  1, F_PRE,   True,  NULL},
    {ID_BTN_LOG10, 1, F_PRE,   True,  NULL},
    {ID_BTN_LN,    1, F_PRE,   True,  NULL},
    {ID_BTN_LOGX,  ARG_SD, F_LOCAL, True,  NULL},
    {ID_BTN_LOGX_D,2, F_PRE,   True,  NULL},
    {ID_BTN_nPm,   ARG_SD, F_LOCAL, False, NULL},
    {ID_BTN_nPm_D, 2, F_LOCAL, False, NULL},
    {ID_BTN_nCm,   ARG_SD, F_LOCAL, False, NULL},
    {ID_BTN_nCm_D, 2, F_LOCAL, False, NULL},
    {ID_BTN_INNER, 2, F_LOCAL, False, NULL},
    {ID_BTN_OUTER, 2, F_LOCAL, False, NULL},
    {ID_BTN_C2F,   1, F_PRE,   False, NULL},
    {ID_BTN_F2C,   1, F_PRE,   False, NULL},
    {ID_BTN_C2K,   1, F_PRE,   False, NULL},
    {ID_BTN_K2C,   1, F_PRE,   False, NULL},
    {ID_BTN_R2H,   1, F_LOCAL, False, NULL},
    {ID_BTN_H2R,   1, F_LOCAL, False, NULL},
    {'=',          2, F_LOCAL, False, NULL},
    {'+',          2, F_LOCAL, False, NULL},
    {'-',          2, F_LOCAL, False, NULL},
    {'*',          2, F_LOCAL, False, NULL},
    {'/',          2, F_LOCAL, False, NULL},
    {ID_BTN_MOD,   2, F_LOCAL, False, NULL},
    {ID_BTN_RTO,   2, F_LOCAL, False, NULL}
};

int nopes=sizeof(opes)/sizeof(*opes);


Boolean use_mathlib=False;



/* local prototypes */

extern double GetConvertRate(UInt16, UInt16, UInt16) SEC_FC;
//extern void ConvertUnit(UInt16, UInt16, ValueStruct*) SEC_FC;
//extern void SetNumsys(UInt16, ValueStruct*);
extern UInt16 SelectNumsys(ValueStruct*, ValueStruct*) SEC_FC;
extern void SelectUnit(ValueStruct*, ValueStruct*, ValueStruct*) SEC_FC;

/*extern UInt32 RandomInt(void);*/
extern double F_rand(void) SEC_FC;
extern double F_pi(void) SEC_FC;
extern double F_lne(void) SEC_FC;
extern double F_randN(double) SEC_FC;
extern double F_fact(double) SEC_FC;
extern double F_not(double) SEC_FC;
extern double F_LShift(double) SEC_FC;
extern double F_RShift(double) SEC_FC;
extern double F_exp2(double) SEC_FC;
extern double F_exp10(double) SEC_FC;
extern double F_c2f(double) SEC_FC;
extern double F_f2c(double) SEC_FC;
extern double F_c2k(double) SEC_FC;
extern double F_k2c(double) SEC_FC;
extern void InvValue(ValueStruct*) SEC_FC;
extern void SquareValue(ValueStruct*) SEC_FC;
extern void CubicValue(ValueStruct*) SEC_FC;
extern void PowerValue(ValueStruct*) SEC_FC;
extern void LogXValue(ValueStruct*) SEC_FC;
extern void nPmValue(ValueStruct*) SEC_FC;
extern void nCmValue(ValueStruct*) SEC_FC;
extern void RGBtoHSVValue(ValueStruct*) SEC_FC;
extern void HSVtoRGBValue(ValueStruct*) SEC_FC;
extern double F_logx(double, double) SEC_FC;
extern double F_and(double, double) SEC_FC;
extern double F_or(double, double) SEC_FC;
extern double F_nor(double, double) SEC_FC;
extern void AddTwoValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void SubTwoValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void MulTwoValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void DivTwoValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void ModTwoValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void RatioTwoValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void InnerProductValues(ValueStruct*, ValueStruct*) SEC_FC;
extern void OuterProductValues(ValueStruct*, ValueStruct*) SEC_FC;

extern void ExecuteConstFunc(ConstFunc*, ValueStruct*) SEC_FC;
extern void ExecuteConstLocalFunc(ConstLocalFunc*, ValueStruct*) SEC_FC;
extern void ExecuteSingleArgFunc(SingleArgFunc*, ValueStruct*) SEC_FC;
extern void ExecuteSingleArgLocalFunc(SingleArgLocalFunc*, ValueStruct*) SEC_FC;
extern void ExecuteDoubleArgFunc(DoubleArgFunc*, ValueStruct*, ValueStruct*) SEC_FC;
extern void ExecuteDoubleArgLocalFunc(DoubleArgLocalFunc*, ValueStruct*, ValueStruct*) SEC_FC;



/* operator initialization */

void SetOperatorsFunc(void)
{
    int i;
    for(i=0; i<nopes; i++){
        switch(opes[i].id){
          case ID_BTN_PI:
            opes[i].func=(void*)F_pi;
            break;
          case ID_BTN_LNE:
            opes[i].func=(void*)F_lne;
            break;
          case ID_BTN_RND:
            opes[i].func=(void*)F_rand;
            break;
          case ID_BTN_RNDN:
            opes[i].func=(void*)F_randN;
            break;
          case ID_BTN_FACT:
            opes[i].func=(void*)F_fact;
            break;
          case ID_BTN_AND:
            opes[i].func=(void*)F_and;
            break;
          case ID_BTN_OR:
            opes[i].func=(void*)F_or;
            break;
          case ID_BTN_NOT:
            opes[i].func=(void*)F_not;
            break;
          case ID_BTN_XOR:
            opes[i].func=(void*)F_nor;
            break;
          case ID_BTN_LSH:
            opes[i].func=(void*)F_LShift;
            break;
          case ID_BTN_RSH:
            opes[i].func=(void*)F_RShift;
            break;
          case ID_BTN_INV:
            opes[i].func=(void*)InvValue;
            break;
          case ID_BTN_SQ:
            opes[i].func=(void*)SquareValue;
            break;
          case ID_BTN_CB:
            opes[i].func=(void*)CubicValue;
            break;
          case ID_BTN_SQR:
            opes[i].func=(void*)sqrt;
            break;
          case ID_BTN_CBR:
            opes[i].func=(void*)cbrt;
            break;
          case ID_BTN_SIN:
            opes[i].func=(void*)sin;
            break;
          case ID_BTN_COS:
            opes[i].func=(void*)cos;
            break;
          case ID_BTN_TAN:
            opes[i].func=(void*)tan;
            break;
          case ID_BTN_ASIN:
            opes[i].func=(void*)asin;
            break;
          case ID_BTN_ACOS:
            opes[i].func=(void*)acos;
            break;
          case ID_BTN_ATAN:
            opes[i].func=(void*)atan;
            break;
          case ID_BTN_SINH:
            opes[i].func=(void*)sinh;
            break;
          case ID_BTN_COSH:
            opes[i].func=(void*)cosh;
            break;
          case ID_BTN_TANH:
            opes[i].func=(void*)tanh;
            break;
          case ID_BTN_ASINH:
            opes[i].func=(void*)asinh;
            break;
          case ID_BTN_ACOSH:
            opes[i].func=(void*)acosh;
            break;
          case ID_BTN_ATANH:
            opes[i].func=(void*)atanh;
            break;
          case ID_BTN_2X:
            opes[i].func=(void*)F_exp2;
            break;
          case ID_BTN_10X:
            opes[i].func=(void*)F_exp10;
            break;
          case ID_BTN_EXP:
            opes[i].func=(void*)exp;
            break;
          case ID_BTN_POW:
            opes[i].func=(void*)PowerValue;
            break;
          case ID_BTN_POW_D:
            opes[i].func=(void*)pow;
            break;
          case ID_BTN_LOG2:
            opes[i].func=(void*)log2;
            break;
          case ID_BTN_LOG10:
            opes[i].func=(void*)log10;
            break;
          case ID_BTN_LN:
            opes[i].func=(void*)log;
            break;
          case ID_BTN_LOGX:
            opes[i].func=(void*)LogXValue;
            break;
          case ID_BTN_LOGX_D:
            opes[i].func=(void*)F_logx;
            break;
          case ID_BTN_nPm:
            opes[i].func=(void*)nPmValue;
            break;
          case ID_BTN_nCm:
            opes[i].func=(void*)nCmValue;
            break;
          case ID_BTN_INNER:
            opes[i].func=(void*)InnerProductValues;
            break;
          case ID_BTN_OUTER:
            opes[i].func=(void*)OuterProductValues;
            break;
          case ID_BTN_C2F:
            opes[i].func=(void*)F_c2f;
            break;
          case ID_BTN_F2C:
            opes[i].func=(void*)F_f2c;
            break;
          case ID_BTN_C2K:
            opes[i].func=(void*)F_c2k;
            break;
          case ID_BTN_K2C:
            opes[i].func=(void*)F_k2c;
            break;
          case ID_BTN_R2H:
            opes[i].func=(void*)RGBtoHSVValue;
            break;
          case ID_BTN_H2R:
            opes[i].func=(void*)HSVtoRGBValue;
            break;
          case '=':
            opes[i].func=(void*)CopyValue;
            break;
          case '+':
            opes[i].func=(void*)AddTwoValues;
            break;
          case '-':
            opes[i].func=(void*)SubTwoValues;
            break;
          case '*':
            opes[i].func=(void*)MulTwoValues;
            break;
          case '/':
            opes[i].func=(void*)DivTwoValues;
            break;
          case ID_BTN_MOD:
            opes[i].func=(void*)ModTwoValues;
            break;
          case ID_BTN_RTO:
            opes[i].func=(void*)RatioTwoValues;
            break;
        }
    }
}

/* util for round */

void VecRoundType(RoundType* rd)
{
    if(rd->disp==RD_NONE){
        rd->disp=RD_DISP;
        rd->type=RD_SGNF;
        rd->cond=RD_OFF;
        rd->b_dgt =4;
        rd->s_dgt =4;
//    }else if(rd->disp==RD_DISP && 4<rd->dgt){
//        rd->dgt=2;
    }
}

void RoundValue(RoundType rd, FlpCompDouble* v)
{
    int i, sg=1, exp=0;
    long itmp;
    double tmp, df;

    if(FlpIsZero(*v)) return;
    if(FlpGetSign(*v)!=0){
        sg=-1;
        FlpSetPositive(*v);
    }
    if(rd.type==RD_BELW){
        for(exp=0; exp<rd.b_dgt; exp++) v->d*=10;
        for(; rd.b_dgt<exp; exp--) v->d/=10;
    }else if(rd.type==RD_SGNF){
        tmp=1.0;
        for(i=0; i<rd.s_dgt; i++) tmp*=10;
        while(tmp<v->d){
            v->d/=10;
            exp--;
        }
        tmp/=10;
        while(v->d<tmp){
            v->d*=10;
            exp++;
        }
    }
    switch(rd.cond){
      case RD_DOWN:
        itmp=v->d;
        v->d=itmp;
        break;
      case RD_OFF:
        itmp=v->d;
        df=v->d-itmp;
        if(0.49999999<df) itmp++;
        v->d=itmp;
        break;
      case RD_UP:
        itmp=v->d;
        df=v->d-itmp;
        if(0.00000001<df) itmp++;
        v->d=itmp;
      default:
        break;
    }
    for(i=0; i<exp; i++) v->d/=10;
    for(i=0; exp<i; i--) v->d*=10;
    v->d*=sg;
}


/* util for Values */

void InitializeValue(ValueStruct* vp)
{
    int j;

    vp->fix=False;
    vp->up=False;
    vp->usys=USYS_NONE;
    vp->unit=UNIT_NONE;
    vp->nsys=NUM_FLOAT;
    vp->nvec=1;
    for(j=0; j<MAX_VEC; j++) vp->v[j].d=0.0;
    StrCopy(vp->str, "0\0");
    vp->nstr=StrLen(vp->str);
}

void CopyValue(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;

    vp1->fix=vp2->fix;
    vp1->up=vp2->up;
    vp1->usys=vp2->usys;
    vp1->unit=vp2->unit;
    vp1->nsys=vp2->nsys;
    vp1->nvec=vp2->nvec;
    StrCopy(vp1->str, vp2->str);
    for(j=0; j<MAX_VEC; j++) vp1->v[j].d=vp2->v[j].d;
    vp1->nstr=vp2->nstr;
}

void SetConstValue(ValueStruct* vp, double d)
{
    InitializeValue(vp);
    vp->fix=True;
    vp->up=True;
    vp->v[0].d=d;
}



/* util for conversion */

double GetConvertRate(UInt16 usys, UInt16 un_fr, UInt16 un_to)
{
    double ret=1.0, r_fr, r_to;
    FlpCompDouble tmp;

    r_fr=GetUnitRate(usys, un_fr);
    r_to=GetUnitRate(usys, un_to);
    tmp.d=r_to;
    if(!FlpIsZero(tmp)){
        ret=r_fr/r_to;
    }
    return ret;
}

void ConvertUnit(UInt16 usys, UInt16 unit, ValueStruct* vp)
{
    int j;
    double rate=1.0;

    if(vp->usys==usys && vp->unit!=unit){
        rate=GetConvertRate(usys, vp->unit, unit);
        for(j=0; j<vp->nvec; j++) vp->v[j].d*=rate;
    }
    vp->usys=usys;
    vp->unit=unit;
}


void SetNumsys(UInt16 nsys, ValueStruct* vp)
{
    UInt16 usys_time, unit_hms, unit_sec;

    GetHMS(&usys_time, &unit_hms, &unit_sec);
    vp->nsys=nsys;
    if(nsys==NUM_TIME){
        if(!(vp->usys==usys_time && vp->unit==unit_hms)){
            ConvertUnit(usys_time, unit_hms, vp);
            update.un=True;
            update.pp=True;
        }
    }else{
        if(vp->usys==usys_time && vp->unit==unit_hms){
            ConvertUnit(usys_time, unit_sec, vp);
            update.un=True;
            update.pp=True;
        }
    }
}

UInt16 SelectNumsys(ValueStruct* org, ValueStruct* vp)
{
    UInt16 ret, ns1, ns2;

    if(org->nsys==vp->nsys) return org->nsys;
    if(org->nsys < vp->nsys){
        ns1=org->nsys;  ns2=vp->nsys;
    }else{
        ns1=vp->nsys;  ns2=org->nsys;
    }
    switch(ns1){
      case NUM_INF:
        ret=NUM_INF;
        break;
//      case NUM_INT:
      case NUM_FLOAT:
        ret=ns2;
        break;
      case NUM_BIN:
      case NUM_OCT:
      case NUM_HEX:
        if(ns2==NUM_HEX){
          ret=org->nsys;
        }else{
          ret=ns2;
        }
        break;
      case NUM_TIME:
        ret=NUM_TIME;
        break;
      default:
        ret=org->nsys;
    }
    return ret;
}

void SetUnit(UInt16 usys, UInt16 unit, ValueStruct* vp)
{
    UInt16 usys_time, unit_hms, unit_sec;

    GetHMS(&usys_time, &unit_hms, &unit_sec);
    vp->usys=usys;
    vp->unit=unit;
    if(usys==usys_time && unit==unit_hms && vp->nsys!=NUM_TIME){
        SetNumsys(NUM_TIME, vp);
        if(op_st.st==ST_OP) vp->up=True;
        update.ns=True;
        update.pb=True;
    }else if(!(usys==usys_time && unit==unit_hms) && vp->nsys==NUM_TIME){
        SetNumsys(NUM_FLOAT, vp);
        if(op_st.st==ST_OP) vp->up=True;
        update.ns=True;
        update.pb=True;
    }
}

void SelectUnit(ValueStruct* ret, ValueStruct* org, ValueStruct* vp)
{
    if(org->usys==USYS_NONE){
        ret->usys=vp->usys;
        ret->unit=vp->unit;
    }else{
        ret->usys=org->usys;
        ret->unit=org->unit;
    }
}



/* util for MathLib */

void OpenMathLib(void)
{
    Err err=0;

    err=SysLibFind(MathLibName, &MathLibRef);
    if(err) err = SysLibLoad(LibType, MathLibCreator, &MathLibRef);
//    ErrFatalDisplayIf(err, "Can't find MathLib");
    if(err){
        use_mathlib=False;
        return;
    }
    err=MathLibOpen(MathLibRef, MathLibVersion);
//    ErrFatalDisplayIf(err, "Can't open MathLib");
    if(err){
        use_mathlib=False;
        return;
    }

    use_mathlib=True;
}

void CloseMathLib(void)
{
    Err err=0;
    UInt16 usecount;

    if(!use_mathlib) return;
    err=MathLibClose(MathLibRef, &usecount);
    ErrFatalDisplayIf(err, "Can't close MathLib.");
    if(usecount==0)
        SysLibRemove(MathLibRef);
}

Boolean IsMathLibOpened(void)
{
    return use_mathlib;
}



/* util for operations */

/*UInt32 RandomInt(void)
{
    Rand_X=Rand_X*Rand_A;
    return Rand_X;
}*/

double F_rand(void)
{
    double ret;

//    ret=(double)RandomInt()/((double)Rand_Max+1);
    ret=(double)SysRandom(0)/((double)sysRandomMax+1);
    return ret;
}

/* functions for contants */

double F_pi(void)
{
    return PI;
}

double F_lne(void)
{
    return LNE;
}



/* single argument operations */

double F_randN(double d)
{
    long n;
    n=(long)d;
    if(n<=0) return 0.0;
    n=(long)(n*F_rand());
    n++;
    return (double)n;
}

double F_fact(double d)
{
    long i, n;
    double ret=1.0;
    n=(long)d;
    if(n<=0) return 0.0;
    for(i=2; i<=n; i++) ret*=(double)i;
    return ret;
}

double F_not(double d)
{
    UInt32 ival;

    if(PrefUBit()){
        ival=d;
        ival=~ival;
        return (double)ival;
    }else{
        ival=(Int32)d;
        ival=~ival;
        return (double)((Int32)ival);
    }
}
double F_LShift(double d)
{
    UInt32 ival;

    if(PrefUBit()){
        ival=d;
        ival=ival<<1;
        return (double)ival;
    }else{
        ival=(Int32)d;
        ival=ival<<1;
        return (double)((Int32)ival);
    }
}
double F_RShift(double d)
{
    UInt32 ival;

    if(PrefUBit()){
        ival=d;
        ival=ival>>1;
        return (double)ival;
    }else{
        ival=(Int32)d;
        ival=ival>>1;
        return (double)((Int32)ival);
    }
}

double F_exp2(double d)
{
    return pow(2, d);
}

double F_exp10(double d)
{
    return pow(10, d);
}

double F_c2f(double d)
{
    return d*9.0/5.0+32.0;
}

double F_f2c(double d)
{
    return (d-32.0)*5.0/9.0;
}

double F_c2k(double d)
{
    return d+273.15;
}

double F_k2c(double d)
{
    return d-273.15;
}

void InvValue(ValueStruct* vp)
{
    ValueStruct tmp;

    SetConstValue(&tmp, 1.0);
    OperateTwoValues('/', &tmp, vp);
    CopyValue(vp, &tmp);
}

void SquareValue(ValueStruct* vp)
{
    ValueStruct tmp;

    CopyValue(&tmp, vp);
    OperateTwoValues('*', vp, &tmp);
}

void CubicValue(ValueStruct* vp)
{
    ValueStruct tmp;

    CopyValue(&tmp, vp);
    OperateTwoValues('*', vp, &tmp);
    OperateTwoValues('*', vp, &tmp);
}

void PowerValue(ValueStruct* vp)
{
    double x, y;

    x=vp->v[0].d;
    y=vp->v[1].d;
    if(vp->nvec==1) y=0;
    SetConstValue(vp, pow(x, y));
}

void LogXValue(ValueStruct* vp)
{
    double x, y;

    x=vp->v[0].d;
    y=vp->v[1].d;
    if(vp->nvec==1 || x==0.0){
        SetConstValue(vp, log10(0.0));
    }else{
        SetConstValue(vp, log10(y)/log10(x));
    }
}

void nPmValue(ValueStruct* vp)
{
    long i, n, m;
    double d=1.0;

    n=(long)vp->v[0].d;
    m=(long)vp->v[1].d;
    if(vp->nvec==1) m=1;
    if(n<=0 || m<=0 || n-m<0){
        SetConstValue(vp, 0.0);
        return;
    }
    for(i=n; n-m<i; i--) d*=(double)i;
    SetConstValue(vp, d);
}

void nCmValue(ValueStruct* vp)
{
    long i, n, m;
    double d=1.0;

    n=(long)vp->v[0].d;
    m=(long)vp->v[1].d;
    if(vp->nvec==1) m=1;
    if(n<=0 || m<=0 || n-m<0){
        SetConstValue(vp, 0.0);
        return;
    }
    if(n-m<m) m=n-m;
    for(i=1; i<=m; i++) d*=(double)(n-i+1)/(double)i;
    SetConstValue(vp, d);
}

void RGBtoHSV(double r, double g, double b, double* h, double* s, double* v)
{
    int sg;
    double max, mid, min;

    r/=255.0;  g/=255.0;  b/=255.0;
    if(r<g){
        if(g<b){
            max=b;
            mid=g;
            min=r;
            *h=240.0;
            sg=-1;
        }else{
            max=g;
            *h=120.0;
            if(r<b){
                mid=b;
                min=r;
                sg=1;
            }else{
                mid=r;
                min=b;
                sg=-1;
            }
        }
    }else{
        if(r<b){
            max=b;
            mid=r;
            min=g;
            *h=240.0;
            sg=1;
        }else{
            max=r;
            *h=0.0;
            if(g<b){
                mid=b;
                min=g;
                sg=-1;
            }else{
                mid=g;
                min=b;
                sg=1;
            }
        }
    }
    if(max==0.0){
        *h=0.0;
        *s=0.0;
        *v=0.0;
        return;
    }
    *v=(int)(max*100.0+0.5);
    *s=(int)((1.0-min/max)*100.0+0.5);
    if(max==min){
        *h=0.0;
    }else{
        *h+=(int)(sg*(mid-min)/(max-min)*60.0+0.5);
    }
}

void  HSVtoRGB(double h, double s, double v, double* r, double* g, double* b)
{
    double* max;  double* mid;  double* min;
    double rr, gg, bb;
    double a;

    s/=100;  v/=100;
    while(h<0) h+=360;
    while(360<=h) h-=360;
    if(0.0<=h && h<60.0){
        max=&rr;  mid=&gg;  min=&bb;  a=h;
    }else if(h<120.0){
        max=&gg;  mid=&rr;  min=&bb;  a=120.0-h;
    }else if(h<180.0){
        max=&gg;  mid=&bb;  min=&rr;  a=h-120.0;
    }else if(h<240.0){
        max=&bb;  mid=&gg;  min=&rr;  a=240.0-h;
    }else if(h<300.0){
        max=&bb;  mid=&rr;  min=&gg;  a=h-240.0;
//    }else if(h<=360.0){
    }else{
        max=&rr;  mid=&bb;  min=&gg;  a=360.0-h;
    }
//    *max=v+s*v;
//    *min=(1.0-s)*v;
    *max=v;
    *min=(1.0-s)*(*max);
    *mid=a/60.0*(*max-*min)+(*min);
    *r=(int)(255*rr+0.5);
    *g=(int)(255*gg+0.5);
    *b=(int)(255*bb+0.5);
}

void RGBtoHSVValue(ValueStruct* vp)
{
    int j;
    double h, s, v;

    for(j=vp->nvec; j<3; j++) vp->v[j].d=0.0;
    vp->nvec=3;
    RGBtoHSV(vp->v[0].d, vp->v[1].d, vp->v[2].d,
             &h, &s, &v);
    vp->v[0].d=h;
    vp->v[1].d=s;
    vp->v[2].d=v;

    vp->fix=True;
    vp->up=True;
}

void HSVtoRGBValue(ValueStruct* vp)
{
    int j;
    double r, g, b;

    for(j=vp->nvec; j<3; j++) vp->v[j].d=0.0;
    vp->nvec=3;
    HSVtoRGB(vp->v[0].d, vp->v[1].d, vp->v[2].d,
             &r, &g, &b);
    vp->v[0].d=r;
    vp->v[1].d=g;
    vp->v[2].d=b;

    vp->fix=True;
    vp->up=True;
}




/* double arguments operations */

double F_logx(double x, double y)
{
    if(x==0.0) return log10(0.0);
    return log10(y)/log10(x);
}

double F_and(double x, double y)
{
    UInt32 ix, iy;

    if(PrefUBit()){
        ix=x;  iy=y;
        return (double)(ix&iy);
    }else{
        ix=(Int32)x;  iy=(Int32)y;
        return (double)((Int32)(ix&iy));
    }
}
double F_or(double x, double y)
{
    UInt32 ix, iy;

    if(PrefUBit()){
        ix=x;  iy=y;
        return (double)(ix|iy);
    }else{
        ix=(Int32)x;  iy=(Int32)y;
        return (double)((Int32)(ix|iy));
    }
}
double F_nor(double x, double y)
{
    UInt32 ix, iy;

    if(PrefUBit()){
        ix=x;  iy=y;
        return (double)(ix^iy);
    }else{
        ix=(Int32)x;  iy=(Int32)y;
        return (double)((Int32)(ix^iy));
    }
}

void AddTwoValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    UInt16 nvec;

    nvec=MAX(vp1->nvec, vp2->nvec);
    for(j=vp1->nvec; j<nvec; j++) vp1->v[j].d=0.0;
    for(j=vp2->nvec; j<nvec; j++) vp2->v[j].d=0.0;
    for(j=0; j<nvec; j++) vp1->v[j].d+=vp2->v[j].d;
    vp1->nvec=nvec;
}

void SubTwoValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    UInt16 nvec;

    nvec=MAX(vp1->nvec, vp2->nvec);
    for(j=vp1->nvec; j<nvec; j++) vp1->v[j].d=0.0;
    for(j=vp2->nvec; j<nvec; j++) vp2->v[j].d=0.0;
    for(j=0; j<nvec; j++) vp1->v[j].d-=vp2->v[j].d;
    vp1->nvec=nvec;
}

void MulTwoValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    UInt16 nvec;
    double tmp;

    if(vp2->nvec==1){
        tmp=vp2->v[0].d;
        for(j=0; j<vp1->nvec; j++) vp1->v[j].d*=tmp;
    }else if(vp1->nvec==1){
        tmp=vp1->v[0].d;
        for(j=0; j<vp2->nvec; j++) vp1->v[j].d=tmp*vp2->v[j].d;
        vp1->nvec=vp2->nvec;
    }else{
        tmp=0.0;
        nvec=MAX(vp1->nvec, vp2->nvec);
        for(j=vp1->nvec; j<nvec; j++) vp1->v[j].d=0.0;
        for(j=vp2->nvec; j<nvec; j++) vp2->v[j].d=0.0;
        for(j=0; j<nvec; j++) tmp+=vp1->v[j].d*vp2->v[j].d;
        vp1->v[0].d=tmp;
        vp1->nvec=1;
    }
}

void DivTwoValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    UInt16 nvec;
    double tmp;

    for(j=0; j<vp2->nvec; j++){
        if(FlpIsZero(vp2->v[j])){
            vp1->nsys=NUM_INF;
            return;
        }
    }

    if(vp2->nvec==1){
        tmp=vp2->v[0].d;
        for(j=0; j<vp1->nvec; j++) vp1->v[j].d/=tmp;
    }else if(vp1->nvec==1){
        tmp=vp1->v[0].d;
        for(j=0; j<vp2->nvec; j++) vp1->v[j].d=tmp/vp2->v[j].d;
        vp1->nvec=vp2->nvec;
    }else{
        nvec=MAX(vp1->nvec, vp2->nvec);
        for(j=vp1->nvec; j<nvec; j++) vp1->v[j].d=0.0;
        for(j=vp2->nvec; j<nvec; j++) vp2->v[j].d=1.0;
        for(j=0; j<nvec; j++) vp1->v[j].d/=vp2->v[j].d;
        vp1->nvec=nvec;
    }
/*    if(vp2->nvec==1){
        for(j=0; j<vp1->nvec; j++) vp1->v[j].d/=vp2->v[0].d;
    }else{
        for(j=0; j<vp1->nvec; j++) vp1->v[j].d/=vp2->v[j].d;
    }*/
}

void ModTwoValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int sg=1;
    double div, mod;

    if(FlpIsZero(vp2->v[0])){
        vp1->nsys=NUM_INF;
        return;
    }

    div=vp1->v[0].d/vp2->v[0].d;
    if(div<0){
        sg=-1;
        div*=-1;
    }
    div=sg*(long)(div);
    mod=vp1->v[0].d-div*vp2->v[0].d;
    vp1->nvec=2;
    vp1->v[0].d=div;
    vp1->v[1].d=mod;
}

void RatioTwoValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    double a=0.0;

    for(j=0; j<vp2->nvec; j++) a+=vp2->v[j].d;
    if(a!=0.0) a=vp1->v[0].d/a;
    for(j=0; j<vp2->nvec; j++) vp1->v[j].d=vp2->v[j].d*a;
    vp1->nvec=vp2->nvec;
}

void InnerProductValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    UInt16 nvec;
    double tmp;

    tmp=0.0;
    nvec=MAX(vp1->nvec, vp2->nvec);
    for(j=vp1->nvec; j<nvec; j++) vp1->v[j].d=0.0;
    for(j=vp2->nvec; j<nvec; j++) vp2->v[j].d=0.0;
    for(j=0; j<nvec; j++) tmp+=vp1->v[j].d*vp2->v[j].d;
    vp1->v[0].d=tmp;
    vp1->nvec=1;
}

void OuterProductValues(ValueStruct* vp1, ValueStruct* vp2)
{
    int i, j, k;
    double v[3];

    for(j=vp1->nvec; j<3; j++) vp1->v[j].d=0.0;
    for(j=vp2->nvec; j<3; j++) vp2->v[j].d=0.0;
    for(i=0; i<3; i++){
        v[i]=0.0;
        for(j=0; j<3; j++){
            for(k=0; k<3; k++){
                if(j==k || i==j || i==k){
                }else if(k-j==1 || k-j==-2){
                    v[i]+=vp1->v[j].d*vp2->v[k].d;
                }else{
                    v[i]-=vp1->v[j].d*vp2->v[k].d;
                }
            }
        }
    }
    vp1->nvec=3;
    vp1->v[0].d=v[0];
    vp1->v[1].d=v[1];
    vp1->v[2].d=v[2];
}

/* util for operations */

OperatorList GetOperatorList(UInt16 op)
{
    int i;
    OperatorList ret={0, 0, 0, False, NULL};

    for(i=0; i<nopes; i++){
        if(opes[i].id!=op) continue;
        return opes[i];
    }
    return ret;
}

UInt16 SingleToDoubleOpeID(UInt16 op)
{
    switch(op){
      case ID_BTN_POW:
        return ID_BTN_POW_D;
        break;
      case ID_BTN_LOGX:
        return ID_BTN_LOGX_D;
        break;
      case ID_BTN_nPm:
        return ID_BTN_nPm_D;
        break;
      case ID_BTN_nCm:
        return ID_BTN_nCm_D;
        break;
    }
    return 0;
}

void ExecuteConstFunc(ConstFunc* func, ValueStruct* vp)
{
        SetConstValue(vp, func());
}

void ExecuteConstLocalFunc(ConstLocalFunc* func, ValueStruct* vp)
{
    func(vp);
}

void ExecuteSingleArgFunc(SingleArgFunc* func, ValueStruct* vp)
{
    int j;

    for(j=0; j<vp->nvec; j++)
            vp->v[j].d=func(vp->v[j].d);
}

void ExecuteSingleArgLocalFunc(SingleArgLocalFunc* func, ValueStruct* vp)
{
    func(vp);
}

void ExecuteDoubleArgFunc(DoubleArgFunc* func, ValueStruct* vp1, ValueStruct* vp2)
{
    int j;
    double tmp;
    UInt16 nvec;

    if(vp2->nvec==1){
        tmp=vp2->v[0].d;
        for(j=0; j<vp1->nvec; j++) vp1->v[j].d=func(vp1->v[j].d, tmp);
    }else if(vp1->nvec==1){
        tmp=vp1->v[0].d;
        for(j=0; j<vp2->nvec; j++) vp1->v[j].d=func(tmp, vp2->v[j].d);
        vp1->nvec=vp2->nvec;
    }else{
        nvec=MAX(vp1->nvec, vp2->nvec);
        for(j=vp1->nvec; j<nvec; j++) vp1->v[j].d=1.0;
        for(j=vp2->nvec; j<nvec; j++) vp2->v[j].d=1.0;
        for(j=0; j<nvec; j++) vp1->v[j].d=func(vp1->v[j].d, vp2->v[j].d);
        vp1->nvec=nvec;
    }
}

void ExecuteDoubleArgLocalFunc(DoubleArgLocalFunc* func, ValueStruct* vp1, ValueStruct* vp2)
{
    func(vp1, vp2);
}

void OperateConstValue(OperatorList opl, ValueStruct* vp)
{
    if(opl.type==F_PRE && opl.func){
        ExecuteConstFunc((ConstFunc*)(opl.func), vp);
    }else if(opl.type==F_LOCAL && opl.func){
        ExecuteConstLocalFunc((ConstLocalFunc*)(opl.func), vp);
    }
    vp->up=True;
    vp->fix=True;
}

void OperateSingleValue(OperatorList opl, ValueStruct* vp)
{
    if(vp->nsys==NUM_INF) return;
    if(opl.mathlib && !use_mathlib){
        AlertDialog(ID_ALERT_INFO, ID_MSG_NeedMathLib);
        return;
    }

    if(opl.type==F_PRE && opl.func){
        ExecuteSingleArgFunc((SingleArgFunc*)(opl.func), vp);
    }else if(opl.type==F_LOCAL && opl.func){
        ExecuteSingleArgLocalFunc((SingleArgLocalFunc*)(opl.func), vp);
    }
    vp->up=True;
    vp->fix=True;
}


void OperateTwoValues(UInt16 op, ValueStruct* vp1, ValueStruct* vp2)
{
    ValueStruct res;
    OperatorList opl;

    opl=GetOperatorList(op);
//    InitializeValue(&res);
    if(opl.id==0) return;
    if(vp1->nsys==NUM_INF){
        return;
    }else if(vp2->nsys==NUM_INF){
        CopyValue(vp1, vp2);
        return;
    }
    if(opl.mathlib && !use_mathlib){
        AlertDialog(ID_ALERT_INFO, ID_MSG_NeedMathLib);
        return;
    }

    SelectUnit(&res, vp1, vp2);
    SetNumsys(SelectNumsys(vp1, vp2), &res);
    ConvertUnit(res.usys, res.unit, vp1);
    ConvertUnit(res.usys, res.unit, vp2);

    if(opl.type==F_PRE && opl.func){
        ExecuteDoubleArgFunc((DoubleArgFunc*)(opl.func), vp1, vp2);
    }else if(opl.type==F_LOCAL && opl.func){
        ExecuteDoubleArgLocalFunc((DoubleArgLocalFunc*)(opl.func), vp1, vp2);
    }

    SetNumsys(res.nsys, vp1);
    vp1->up=True;
    vp1->fix=True;
}
