#include "mxcl.h"
#include "mxcl_id.h"


typedef struct {
    OperationStatus op_st;
    ValueStruct bf;
    ValueStruct st;
    ValueStruct mm;
} Status;

OperationStatus op_st;

ValueStruct val_bf;
ValueStruct val_st;
ValueStruct val_mm;
//ValueStruct val_sum;

//UInt16 count_sum;

//Char debug_msg[64];



/* declarations of functions */

extern void SetValueToBuffer(ValueStruct*);
extern Boolean OperatorDoubleHandling(OperatorList);
extern Boolean OperatorHandling(UInt16);
extern Boolean KeyHandling(WChar);
extern Boolean ButtonHandling(UInt16);
extern Boolean MenuHandling(UInt16);
extern Boolean PopupHandling(CommonEventPtr);
extern Boolean FormMainHandleEvent(CommonEventPtr);


/* event handling */

void SetValueToBuffer(ValueStruct* vp)
{
    CopyValue(&val_bf, vp);
    if(op_st.st!=ST_BF) op_st.st=ST_BF;
    SetUpdateFlags();
    SetUpdateNumSys();
    SetUpdatePushBtn();
    SetUpdateUnit();
    SetUpdatePopup();
    SetUpdateMarks();
    op_st.fx=val_bf.fix;
}

Boolean OperatorDoubleHandling(OperatorList opl)
{
    Boolean ret=False;

    if(op_st.st==ST_OP){
        op_st.op=opl.id;
        SetUpdateOperator();
        ret=True;
    }else if(val_bf.fix || StrToVal(&val_bf)){
        OperateTwoValues(op_st.op, &val_st, &val_bf);
        op_st.op=opl.id;
        op_st.st=ST_OP;
        InitializeValue(&val_bf);
        SetUpdateOperator();
//        val_bf.nsys=val_st.nsys;
/*        if(op_st.op=='=' || op_st.op=='+' || op_st.op=='-'){
            val_bf.nsys=val_st.nsys;
            val_bf.usys=val_st.usys;
            val_bf.unit=val_st.unit;
        }*/
        SetUpdateNumSys();
        SetUpdatePushBtn();
        SetUpdateUnit();
        SetUpdatePopup();
        SetUpdateMarks();
        op_st.fx=val_st.fix;
        ret=True;
    }else{
        ret=False;
    }
    return ret;
}

Boolean OperatorHandling(UInt16 op)
{
    Boolean ret=False;
    OperatorList opl;

    opl=GetOperatorList(op);
    if(opl.id==0) return ret;

    if(opl.args==ARG_SD){
        UInt16 nvec=0;
        if(op_st.st==ST_OP){
            nvec=val_st.nvec;
        }else if(val_bf.fix || StrToVal(&val_bf)){
            nvec=val_bf.nvec;
        }else{
            return ret;
        }
        if(nvec<2){
            op=SingleToDoubleOpeID(opl.id);
            opl=GetOperatorList(op);
            if(opl.id==0) return ret;
        }else{
            opl.args=1;
        }
    }
    if(opl.args==0){
        ValueStruct tmp;
        OperateConstValue(opl, &tmp);
        SetValueToBuffer(&tmp);
        ret=True;
    }else if(opl.args==1){
        if(op_st.st==ST_OP){
            OperateSingleValue(opl, &val_st);
            op_st.op='=';
            SetUpdateMarks();
            op_st.fx=val_st.fix;
            ret=True;
        }else if(val_bf.fix || StrToVal(&val_bf)){
            OperateSingleValue(opl, &val_bf);
            SetUpdateMarks();
            op_st.fx=val_bf.fix;
            ret=True;
        }else{
            ret=False;
        }
    }else if(opl.args==2){
        ret=OperatorDoubleHandling(opl);
    }
    return ret;
}


Boolean KeyHandling(WChar ch)
{
    Boolean ret=False;
    UInt16 nsys;
    ValueStruct tmp;

    if(IsAddChar(ch)){
        if(MAX_DISP_CHAR<=val_bf.nstr) return False;
        if(val_bf.fix){
//            InitializeValue(&val_bf);
            val_bf.fix=False;
            SetUpdateMarks();
            op_st.fx=val_bf.fix;
        }
        /* add character */
        CopyValue(&tmp, &val_bf);
        ChopZero(&tmp, ch);
        tmp.str[tmp.nstr]=ch;  tmp.nstr++;
        if(ch==','){
            if(MAX_VEC==val_bf.nvec) return False;
            tmp.nvec++;
            if(val_bf.nstr<MAX_DISP_CHAR){
                tmp.str[tmp.nstr]=' ';  tmp.nstr++;
            }
        }
        tmp.str[tmp.nstr]='\0';
        nsys=CharToNumsys(ch, tmp.nsys);
        if(nsys==NUM_FLOAT && tmp.nsys==NUM_TIME) nsys=0;
        if(nsys && !ParseNoError(tmp.str, tmp.nstr, nsys)){
            ret=False;
        }else{
            if(nsys){
                SetNumsys(nsys, &tmp);
                SetUpdateNumSys();
                SetUpdatePushBtn();
            }
            CopyValue(&val_bf, &tmp);
            if(op_st.st!=ST_BF){
                op_st.st=ST_BF;
                if(op_st.op=='+' || op_st.op=='-'){
                    val_bf.nsys=val_st.nsys;
                    val_bf.usys=val_st.usys;
                    val_bf.unit=val_st.unit;
                }
                SetUpdateNumSys();
                SetUpdatePushBtn();
                SetUpdateUnit();
                SetUpdatePopup();
                SetUpdateMarks();
                op_st.fx=val_bf.fix;
            }
            SetUpdateValue();
            ret=True;
        }
    }else if(ch=='\b'){
        if(op_st.st==ST_BF && 0<val_bf.nstr){
            if(val_bf.fix){
                val_bf.fix=False;
                SetUpdateMarks();
                op_st.fx=val_bf.fix;
            }
            val_bf.nstr--;
            if(val_bf.str[val_bf.nstr]==',' && 1<val_bf.nvec)
                    val_bf.nvec--;
            val_bf.str[val_bf.nstr]='\0';
            if(val_bf.str[0]=='\0'){
                val_bf.str[0]='0';
                val_bf.str[1]='\0';
                val_bf.nstr++;
            }
            SetUpdateValue();
            ret=True;
        }else{
            ret=False;
        }
    }else if(ch=='%'){
        InitializeValue(&tmp);
        tmp.v[0].d=0.01;
        if(op_st.st==ST_OP){
            OperateTwoValues('*', &val_st, &tmp);
            ret=True;
        }else if(val_bf.fix || StrToVal(&val_bf)){
            OperateTwoValues('*', &val_bf, &tmp);
            SetUnit(USYS_NONE, UNIT_NONE, &val_bf);
            if(op_st.op=='+' || op_st.op=='-')
                    OperateTwoValues('*', &val_bf, &val_st);
            SetUpdateUnit();
            SetUpdatePopup();
            SetUpdateMarks();
            op_st.fx=val_bf.fix;
            ret=True;
        }else{
            ret=False;
        }
    }else{
        ret=OperatorHandling(ch);
    }
    return ret;
}

Boolean ButtonHandling(UInt16 id)
{
    Boolean ret=False;
    int i, j;
    UInt16 id_btn, nsys;
    ValueStruct tmp;
    FormPtr frm;

    switch(id){
      case ID_BTN_A:
      case ID_BTN_B:
      case ID_BTN_C:
      case ID_BTN_D:
      case ID_BTN_E:
      case ID_BTN_F:
        frm=FrmGetFormPtr(PrefCurrentForm());
//        frm=FrmGetActiveForm();
        FrmSetControlValue(frm, FrmGetObjectIndex(frm, id), 0);
        ret=KeyHandling('A'+id-ID_BTN_A);
        break;
      case ID_BTN_BASC:
        frm=FrmInitForm(ID_FORM_BASC);
        id_btn=FrmDoDialog(frm);
        FrmDeleteForm(frm);
        ret=ButtonHandling(id_btn);
        break;
      case ID_BTN_MATH:
        frm=FrmInitForm(ID_FORM_MATH);
        id_btn=FrmDoDialog(frm);
        FrmDeleteForm(frm);
        ret=ButtonHandling(id_btn);
        break;
      case ID_BTN_MISC:
        frm=FrmInitForm(ID_FORM_MISC);
        id_btn=FrmDoDialog(frm);
        FrmDeleteForm(frm);
        ret=ButtonHandling(id_btn);
        break;
      case ID_PSBTN_STD:
      case ID_PSBTN_EXP:
        PrefSetCurrentForm(PushBtnIDToFormID(id));
        FrmGotoForm(PrefCurrentForm());
        ret=True;
        break;
      case ID_PSBTN_FL:
      case ID_PSBTN_BN:
      case ID_PSBTN_OC:
      case ID_PSBTN_HX:
      case ID_PSBTN_DT:
      case ID_PSBTN_TM:
        nsys=PushBtnIDToNumsys(id);
        if(op_st.st==ST_OP){
            SetNumsys(nsys, &val_st);
            val_st.up=True;
        }else if(val_bf.fix){
            SetNumsys(nsys, &val_bf);
            val_bf.up=True;
        }else{
            if(!ParseNoError(val_bf.str, val_bf.nstr, nsys)){
                SetUpdatePushBtn();
                break;
            }
            SetNumsys(nsys, &val_bf);
            SetUpdateValue();
        }
        SetUpdateNumSys();
        ret=True;
        break;
      case ID_BTN_P_M:
        if(op_st.st==ST_OP){
            for(j=0; j<MAX_VEC; j++) FlpNegate(val_st.v[j]);
            val_st.up=True;
        }else if(val_bf.fix){
            for(j=0; j<MAX_VEC; j++) FlpNegate(val_bf.v[j]);
            val_bf.up=True;
        }else if(val_bf.str[0]=='0' && val_bf.str[1]=='\0'){
        }else{
            i=val_bf.nstr-1;
            while(0<i){
                if(val_bf.str[i-1]==' '
                   || val_bf.str[i-1]==',') break;
                i--;
            }
            if(val_bf.str[i]=='-'){
                for(; i<val_bf.nstr; i++) val_bf.str[i]=val_bf.str[i+1];
                val_bf.nstr--;
            }else if(val_bf.str[i]=='\0'){
            }else{
                int k;
                for(k=val_bf.nstr+1; i<k; k--) val_bf.str[k]=val_bf.str[k-1];
                val_bf.str[k]='-';
                val_bf.nstr++;
            }
        }
        SetUpdateValue();
        ret=True;
        break;
      case ID_BTN_MP:
      case ID_BTN_MM:
        if(op_st.st==ST_BF) KeyHandling('=');
        OperateTwoValues(MemBtnIDToChar(id), &val_mm, &val_st);
        op_st.mm=True;
        SetUpdateMarks();
        ret=True;
        break;
      case ID_BTN_MR:
        if(!op_st.mm){
            ret=True;
            break;
        }
        SetValueToBuffer(&val_mm);
        ret=True;
        break;
      case ID_BTN_MC:
        InitializeValue(&val_mm);
        op_st.mm=False;
        SetUpdateMarks();
        ret=True;
        break;
      case ID_BTN_CLS:
        InitializeValue(&val_st);
        InitializeValue(&val_bf);
//        InitializeStatus();
        op_st.op='=';
        op_st.st=ST_BF;
        SetUpdateFlags();
        op_st.fx=val_bf.fix;
        ret=True;
        break;
      case ID_BTN_CLE:
        tmp.usys=val_bf.usys;
        tmp.unit=val_bf.unit;
        InitializeValue(&val_bf);
        val_bf.usys=tmp.usys;
        val_bf.unit=tmp.unit;
        SetUpdateValue();
        SetUpdateNumSys();
        SetUpdatePushBtn();
        SetUpdateUnit();
        SetUpdateMarks();
        if(op_st.st==ST_OP){
            op_st.fx=val_st.fix;
        }else{
            op_st.fx=val_bf.fix;
        }
        ret=True;
        break;
      default:
        ret=OperatorHandling(id);
/*        if(IsOperatorSingleBtn(id)){
            if(op_st.st==ST_OP){
                OperateSingleValue(id, &val_st);
                op_st.op='=';
                ret=True;
            }else if(val_bf.fix || StrToVal(&val_bf)){
                OperateSingleValue(id, &val_bf);
                op_st.fx=val_bf.fix;
                ret=True;
            }else{
                ret=False;
            }
        }else if(IsOperatorDoubleBtn(id)){
            ret=OperatorDoubleHandling(id);
        }*/
    }
    return ret;
}

Boolean MenuHandling(UInt16 id)
{
    Boolean ret=True;
    FormPtr frm;

    switch(id){
      case ID_MENU_UNIT_LIST:
        FrmGotoForm(ID_FORM_UNIT_LIST);
//        UnitListModal();
        break;
      case ID_MENU_ABOUT:
        frm=FrmInitForm(ID_ABOUT);
        FrmDoDialog(frm);
        FrmDeleteForm(frm);
        break;
      case ID_MENU_QUIT:
        QuitApp();
        break;
      default:
    }
    return ret;
}

Boolean PopupHandling(CommonEventPtr e)
{
//    Char* str;
    Boolean ret=True;
    UInt16 usys, us, un, listID;
    Int16 num=CommonPopupSelect(e);

    listID=CommonPopupID(e);
    if(listID==ID_LIST_USYS){
        usys=0;
//        str=pop_us;
    }else if(listID==ID_LIST_UNIT){
        usys=GetSelectedUnitSystem();
//        str=pop_un;
    }else{
        return ret;
    }
    SetUnitListLabel(usys, num,
                     e->data.popSelect.listP,
                     e->data.popSelect.controlP);
//    GetUnitName(usys, num+1, str);
//    LstSetSelection(e->data.popSelect.listP, num);
//    CtlSetLabel(e->data.popSelect.controlP, str);
    if(!usys) SetUnitList(num+1);
    us=GetSelectedUnitSystem();
    un=GetSelectedUnit();
    if(op_st.st==ST_OP){
        ConvertUnit(us, un, &val_st);
        SetUnit(us, un, &val_st);
        val_st.up=True;
    }else if(val_bf.fix){
        ConvertUnit(us, un, &val_bf);
        SetUnit(us, un, &val_bf);
        val_bf.up=True;
    }else{
        SetUnit(us, un, &val_bf);
    }
    SetUpdateUnit();
    return ret;
}

Boolean FormMainHandleEvent(CommonEventPtr e)
{
    Boolean ret = False;
    WChar ch=0;
    ValueStruct* vp;

    CALLBACK_PROLOGUE

    switch(CommonEventType(e)){
      case CommonKeyDownEvent:
        ret=KeyHandling(CommonKeyChar(e));
        break;
      case CommonMenuEvent:
        ret=MenuHandling(CommonMenuID(e));
        break;
      case CommonButtonEvent:
        ch=ButtonIDToChar(CommonButtonID(e));
        if(ch){
            ret=KeyHandling(ch);
        }else{
            ret=ButtonHandling(CommonButtonID(e));
        }
        break;
      case CommonPopupEvent:
        ret=PopupHandling(e);
        break;
      case appStopEvent:
        QuitApp();
        ret=True;
        break;
      default:
    }
    if(op_st.st==ST_BF){
        vp=&val_bf;
    }else{
        vp=&val_st;
    }
    if(vp->up){
        ValToStr(vp);
        vp->up=False;
        SetUpdateValue();
    }
    DrawWindowMain(vp);

    CALLBACK_EPILOGUE
    return ret;
}

Boolean FormMainHandleEventPalm(EventPtr e)
{
    return FormMainHandleEvent((CommonEventPtr)e);
}


/* initialize app */

void InitializeStatus(void)
{
    op_st.op='=';
    op_st.st=ST_BF;
    op_st.mm=False;
    op_st.fx=False;
}

/*void InitializeSum(void)
{
    InitializeValue(&val_sum);
    count_sum=0;
}*/

void InitializeVariables(void)
{
    /* initialize Values */
    InitializeValue(&val_bf);
    InitializeValue(&val_st);
    InitializeValue(&val_mm);

    /* initialize sum */
//    InitializeSum();
}

void GetStatus(void)
{
    UInt16 stat_size;
    Int16 ver;
    Status stat;

    stat_size=sizeof(Status);
    ver=PrefGetAppPreferences(CREATOR_ID, 0, &stat, &stat_size, False);
    if(ver==noPreferenceFound){
        InitializeStatus();
        InitializeVariables();
    }else if(ver==STAT_VER && stat_size==sizeof(Status)){
        op_st=stat.op_st;
        CopyValue(&val_bf, &(stat.bf));
        CopyValue(&val_st, &(stat.st));
        CopyValue(&val_mm, &(stat.mm));
//    }else if(ver==100){
    }else{
        InitializeStatus();
        InitializeVariables();
    }
}

void OpenFormMain(FormPtr frm)
{
    Err err;

    SetUpdateFrame();
    SetUpdateFlags();

/*    InitializeStatus();
    InitializeVariables();*/
    InitializeUIConstants();

    FrmSetEventHandler(frm, (FormEventHandlerType*)FormMainHandleEventPalm);
    FrmSetControlGroupSelection(frm, ID_PSBTN_FORM_GROUP,
                                FormIDToPushBtnID(PrefCurrentForm()));

    /* open unit db */
    if((err=OpenUnitDB(False))){
//        StrPrintF(debug_msg, "Cannot open unit DB. ERROR CODE: %d", err);
//        FrmCustomAlert(ID_DEBUGALERT, debug_msg, "", "");
        ErrFatalDisplayIf(err, "Can't open unit DB.");
        QuitApp();
        return;
    }

    SetUnitList(0);
}

/* close app */


void SaveStatus(void)
{
    Status stat;

    stat.op_st=op_st;
    CopyValue(&(stat.bf), &val_bf);
    CopyValue(&(stat.st), &val_st);
    CopyValue(&(stat.mm), &val_mm);
    PrefSetAppPreferences(CREATOR_ID, 0, STAT_VER, &stat, sizeof(Status), False);
}
