#define WID 160
#define HGT 160

#define MAX_NAME_CHAR    16
#define MAX_SIGN_CHAR     8


/* define IDs */
#define ID_FORM_STD   1000
#define ID_FORM_EXP   2000

#define ID_PSBTN_NSYS_GROUP  1
#define ID_PSBTN_FL    11
#define ID_PSBTN_BN    12
#define ID_PSBTN_OC    13
#define ID_PSBTN_HX    14
#define ID_PSBTN_TM    15
#define ID_PSBTN_DT    16

#define ID_PSBTN_FORM_GROUP  2
#define ID_PSBTN_STD   21
#define ID_PSBTN_EXP   22

#define ID_BTN_0       30
#define ID_BTN_1       31
#define ID_BTN_2       32
#define ID_BTN_3       33
#define ID_BTN_4       34
#define ID_BTN_5       35
#define ID_BTN_6       36
#define ID_BTN_7       37
#define ID_BTN_8       38
#define ID_BTN_9       39

#define ID_PSBTN_ABC_GROUP 3
#define ID_BTN_A       41
#define ID_BTN_B       42
#define ID_BTN_C       43
#define ID_BTN_D       44
#define ID_BTN_E       45
#define ID_BTN_F       46

#define ID_BTN_PLS     51
#define ID_BTN_MNS     52
#define ID_BTN_AST     53
#define ID_BTN_SLS     54
#define ID_BTN_EQL     55
#define ID_BTN_P_M     56
#define ID_BTN_PCT     57

#define ID_BTN_MP      61
#define ID_BTN_MM      62
#define ID_BTN_MR      63
#define ID_BTN_MC      64
#define ID_BTN_SUM     65
#define ID_BTN_AVE     66

#define ID_BTN_CLS     71
#define ID_BTN_CLE     72

#define ID_BTN_BS      75
#define ID_BTN_PRD     76
#define ID_BTN_CLN     77
#define ID_BTN_CMM     78

#define ID_BTN_ABC     91
#define ID_BTN_X1      92
#define ID_BTN_X2      93
#define ID_BTN_X3      94
#define ID_BTN_X4      95
#define ID_BTN_X5      96
#define ID_BTN_BASC    97
#define ID_BTN_MATH    98
#define ID_BTN_MISC    99

#define ID_LIST_USYS   101
#define ID_LIST_UNIT   102
#define ID_POPUP_USYS  106
#define ID_POPUP_UNIT  107


#define ID_FORM_BASC   3200
#define ID_FORM_MATH   3400
#define ID_FORM_MISC   3600

#define ID_BTN_LB1   111
#define ID_BTN_LB2   112
#define ID_BTN_LB3   113
#define ID_BTN_LB4   114
#define ID_BTN_LB5   115
#define ID_BTN_LB6   116
#define ID_BTN_LB7   117
#define ID_BTN_LB8   118
#define ID_BTN_LB9   119

#define ID_BTN_INV   121
#define ID_BTN_SQ    122
#define ID_BTN_CB    123
#define ID_BTN_SQR   124
#define ID_BTN_CBR   125

#define ID_BTN_MOD   126
#define ID_BTN_RTO   127
#define ID_BTN_FACT  128

#define ID_BTN_AND   131
#define ID_BTN_OR    132
#define ID_BTN_NOT   133
#define ID_BTN_XOR   134
#define ID_BTN_LSH   135
#define ID_BTN_RSH   136

#define ID_BTN_RND   138
#define ID_BTN_RNDN  139

#define ID_BTN_PI    141
#define ID_BTN_LNE   142

#define ID_BTN_SIN   151
#define ID_BTN_COS   152
#define ID_BTN_TAN   153
#define ID_BTN_ASIN  154
#define ID_BTN_ACOS  155
#define ID_BTN_ATAN  156
#define ID_BTN_SINH  157
#define ID_BTN_COSH  158
#define ID_BTN_TANH  159
#define ID_BTN_ASINH 160
#define ID_BTN_ACOSH 161
#define ID_BTN_ATANH 162

#define ID_BTN_2X    166
#define ID_BTN_10X   167
#define ID_BTN_EXP   168
#define ID_BTN_POW   169
#define ID_BTN_POW_D 170
#define ID_BTN_LOG2  171
#define ID_BTN_LOG10 172
#define ID_BTN_LN    173
#define ID_BTN_LOGX  174
#define ID_BTN_LOGX_D  175

#define ID_BTN_nPm   176
#define ID_BTN_nPm_D 177
#define ID_BTN_nCm   178
#define ID_BTN_nCm_D 179

#define ID_BTN_INNER 188
#define ID_BTN_OUTER 189

#define ID_BTN_C2F   191
#define ID_BTN_F2C   192
#define ID_BTN_C2K   193
#define ID_BTN_K2C   194
#define ID_BTN_R2H   196
#define ID_BTN_H2R   197

#define ID_BTN_DONE  199


#define ID_MENU_MAIN       6000
#define ID_MENU_UNIT_LIST  6001
#define ID_MENU_QUIT       6003
#define ID_MENU_ABOUT      6004

#define ID_FORM_UNIT_LIST   6200
#define ID_UL_LIST_USYS     6201
#define ID_UL_LIST_UNIT     6202
#define ID_UL_BTN_CLOSE     6221
#define ID_UL_US_BTN_ADD    6231
#define ID_UL_US_BTN_EDIT   6232
#define ID_UL_US_BTN_DEL    6233
#define ID_UL_US_BTN_UP     6234
#define ID_UL_US_BTN_DOWN   6235
#define ID_UL_UL_BTN_ADD    6241
#define ID_UL_UL_BTN_EDIT   6242
#define ID_UL_UL_BTN_DEL    6243
#define ID_UL_UL_BTN_UP     6244
#define ID_UL_UL_BTN_DOWN   6245

#define ID_FORM_UN_PROP     6300
#define ID_UNP_BTN_OK       6301
#define ID_UNP_BTN_CANCEL   6302
#define ID_UNP_LB1          6303
#define ID_UNP_LB2          6304
#define ID_UNP_LB3          6305
#define ID_UNP_FIELD_NAME   6306
#define ID_UNP_FIELD_SIGN   6307
#define ID_UNP_FIELD_RATE   6308

#define ID_FORM_US_PROP     6400
#define ID_USP_BTN_OK       6401
#define ID_USP_BTN_CANCEL   6402
#define ID_USP_LB1          6403
#define ID_USP_FIELD_NAME   6406

#define ID_ALERT_DEL_UN     6701
#define ID_ALERT_DEL_US     6702
#define ID_ALERT_INFO       6711
#define ID_ALERT_WARNING    6713
#define ID_ALERT_ERROR      6714

#define ID_ABOUT           7000
#define ID_ABOUT_LB1       7001
#define ID_ABOUT_LB2       7002
#define ID_ABOUT_LB3       7003
#define ID_ABOUT_LB4       7004
#define ID_ABOUT_LB5       7005
#define ID_ABOUT_LB6       7006
#define ID_ABOUT_LB7       7007
#define ID_ABOUT_OK        7008

#define ID_MSG_NeedMathLib 7501
#define ID_HELP_BASC       7701
#define ID_HELP_MATH       7702
#define ID_HELP_MISC       7703



#define ID_DEBUGALERT  8000


/* resource constants */

/*
#define DISP_X       8
#define DISP_Y      20
#define DISP_W (WID-2*DISP_X)
#define DISP_H      16
#define DISP_BD      2
#define DISP_OP_W   16
#define DISP_UN_W   30
#define DISP_SUB_H  10
#define DISP_SUB_Y (DISP_Y-DISP_SUB_H-DISP_BD)
#define DISP_NS_W   24*/
/*#define DISP_W  144*/
//#define DISP_OP_X  8
//#define DISP_OP_Y 16
//#define DISP_NS_X 16
#define BTN_W 24
#define BTN_H 16
#define BTN_FONT 7
#define BTN_EXP_W 20
#define BTN_EXP_H 13
#define BTN_EXP_FONT 1
#define BTN_Y   45
#define SUBBTN_W  23
#define SUBBTN_H  11
#define PBTN_W  10
#define PBTN_H   9
#define PP_H   PBTN_H
#define PP_USYS_X  45
#define PP_USYS_W  45
#define LST_USYS_W 45
#define PP_UNIT_X (PP_USYS_X+PP_USYS_W)
#define PP_UNIT_W  60
#define LST_UNIT_W 60

/* pattern A
#define UL_USYS_W   90
#define UL_UNIT_W  115
#define UL_UL_BTN_W 30
#define UL_BTN_H    10
#define SYMBOL7_FONT 5
#define UL_NUM_W    15
#define UL_SIGN_W    0
#define UL_NAME_W   45
#define UL_RATE_W   50
*/

/* pattern B*/
#define UL_USYS_W   86
#define UL_UNIT_W  144
#define UL_UL_BTN_W    30
#define UL_UL_BTNS_W   19
#define UL_BTN_H       10
#define SYMBOL7_FONT 5
#define UL_NUM_W    20
#define UL_SIGN_W    0
#define UL_NAME_W   60
#define UL_RATE_W   60
#define UL_FIELD_W  90

#define FORM_USP_H  70
#define FORM_UNP_H  90

#define FORM_BASC_H  120
#define FORM_MATH_H  HGT-4
#define FORM_MISC_H  110

#define MAX_LIST 8

