#include "mxcl.h"
#include "mxcl_id.h"


typedef struct {
    UInt16 id_form;
    Char thSpt;
    Char dcSpt;
    double dmin;
    double dmax;
    RoundType rd;
    Boolean z_pad;
    Boolean u_bit;
} Prefs;

Prefs pref;





/* local prototypes */

extern void InitializePrefs(Prefs*);






/* preferences */

UInt16 PrefCurrentForm(void)
{
    return pref.id_form;
}
void PrefSetCurrentForm(UInt16 id_form)
{
    pref.id_form=id_form;
}

Char PrefDecimalSeparator(void)
{
    return pref.dcSpt;
}
Char PrefThousandSeparator(void)
{
    return pref.thSpt;
}

void PrefDMinMax(double* dmin, double* dmax)
{
    *dmin=pref.dmin;
    *dmax=pref.dmax;
}
void PrefSetDMinMax(double dmin, double dmax)
{
    pref.dmin=dmin;
    pref.dmax=dmax;
}

RoundType PrefRoundType(void)
{
    return pref.rd;
}

Boolean PrefZeroPadding(void)
{
    return pref.z_pad;
}

Boolean PrefUBit(void)
{
    return pref.u_bit;
}

void InitializePrefs(Prefs* pf)
{
    pf->id_form=ID_FORM_STD;
    pf->dmin=PREF_DMIN;
    pf->dmax=PREF_DMAX;
    pf->rd.disp=RD_NONE;
    pf->rd.type=RD_BELW;
    pf->rd.cond=RD_OFF;
    pf->rd.b_dgt =2;
    pf->rd.s_dgt =2;
    pf->z_pad=False;
    pf->u_bit=False;  // ver 1.02
}

void GetPrefs(void)
{
    UInt16 pref_size;
    Int16 ver;
    NumberFormatType numFormat;

    pref_size=sizeof(Prefs);
    ver=PrefGetAppPreferences(CREATOR_ID, 0, &pref, &pref_size, True);
    if(ver==noPreferenceFound){
        InitializePrefs(&pref);
    }else if(ver==PREF_VER && pref_size==sizeof(Prefs)){
    }else if(ver==100){
        pref.u_bit=False;
    }else{
        InitializePrefs(&pref);
    }

    numFormat=(NumberFormatType)
                      PrefGetPreference(prefNumberFormat);
    LocGetNumberSeparators
            (numFormat, &(pref.thSpt), &(pref.dcSpt));
}

void SavePrefs(void)
{
    PrefSetAppPreferences(CREATOR_ID, 0, PREF_VER, &pref, sizeof(Prefs), True);
}

