#include <PalmOS.h>
#include <FloatMgr.h>
#include <Font.h>
#include "MathLib.h"



/* definition for compilation */

#ifndef __CALLBACK_H__
#define __CALLBACK_H__

register void *reg_a4 asm("%a4");

#define CALLBACK_PROLOGUE \
    void *save_a4 = reg_a4;  asm("move.l %%a5, %%a4; sub.l #edata,%%a4" : :);
#define CALLBACK_EPILOGUE reg_a4=save_a4;

#endif

#define SEC_FC  __attribute__ ((section ("sec_func")))


/* definition for common structs */

typedef EventType CommonEventType;
typedef EventPtr  CommonEventPtr;

#define CommonKeyDownEvent keyDownEvent
#define CommonButtonEvent  ctlSelectEvent
#define CommonPopupEvent   popSelectEvent
#define CommonMenuEvent    menuEvent

#define CommonEventType(e) (e->eType)
#define CommonKeyChar(e)   (e->data.keyDown.chr)
#define CommonButtonID(e)  (e->data.ctlSelect.controlID)
#define CommonMenuID(e)    (e->data.menu.itemID)
#define CommonPopupID(e)   (e->data.popSelect.listID)
#define CommonPopupSelect(e) (e->data.popSelect.selection)


/* definition for application profiles */

#define CREATOR_ID   'MxCl'
#define UDB_TYPE     'UNIT'
#define UDB_NAME     "mxcl_units"
#define PREF_VER     102
#define STAT_VER     100



/* constants for forms */

#define DISP_LARGE_FONT largeBoldFont
#define DISP_SMALL_FONT stdFont
#define SUB_FONT  stdFont
#define MK_FONT   boldFont

