#include "mxcl.h"
#include "mxcl_id.h"

Char pop_us[MAX_NAME_CHAR];
Char pop_un[MAX_NAME_CHAR];

RectangleType disp_vl, disp_op, disp_un,
              disp_ns, disp_mk, disp_fr;

FontID disp_font, disp_l_font, disp_s_font;

UpdateStatus update=
{
    False, False, False, False,
    False, False, False, False
};



/* local prototypes */

extern Int16 FontHeight(FontID);
extern void InitializeDispConstants(RectangleType*, RectangleType* disp_op,
                                    RectangleType*, RectangleType*,
                                    RectangleType*, RectangleType*);
extern void InitializeFonts(FontID*, FontID*);
extern void DrawUnitList(Int16, RectangleType*, Char**);
extern void DrawUnitSystemList(Int16, RectangleType*, Char**);
extern void DrawValue(ValueStruct*);
extern void DrawOperator(void);
extern void DrawMarks(void);
extern void DrawNumSys(ValueStruct*);
extern void SetPushBtn(ValueStruct*);
extern void DrawUnit(ValueStruct*);
extern void SetPopup(ValueStruct*);
extern void DrawDisplayFrame(void);



/* util for UI */

Int16 FontHeight(FontID font)
{
    switch(font){
      case largeBoldFont:
        return 16;
        break;
      case boldFont:
        return 13;
        break;
      default:
        return 13;
        break;
    }
}


/* util for messages */

void AlertDialog(UInt16 alert_id, UInt16 msg_id)
{
    MemHandle h;
    Char* s;

    h=DmGet1Resource('tSTR', msg_id);
    s=MemHandleLock(h);
//    StrCopy(debug_msg, s);
    FrmCustomAlert(alert_id, s, "", "");
    MemHandleUnlock(h);
    DmReleaseResource(h);
}




/* util for display */

void InitializeDispConstants(RectangleType* disp_vl,
                             RectangleType* disp_op,
                             RectangleType* disp_un,
                             RectangleType* disp_ns,
                             RectangleType* disp_mk,
                             RectangleType* disp_fr)
{
/*    disp_op->topLeft.x=DISP_X;
    disp_op->topLeft.y=DISP_Y;
    disp_op->extent.x =DISP_OP_W;
    disp_op->extent.y =DISP_H;
    disp_mk->topLeft.x=DISP_X;
    disp_mk->topLeft.y=DISP_SUB_Y;
    disp_mk->extent.x =DISP_OP_W;
    disp_mk->extent.y =DISP_SUB_H;
    disp_un->topLeft.x=DISP_X + DISP_W - DISP_UN_W;
    disp_un->topLeft.y=DISP_Y;
    disp_un->extent.x =DISP_UN_W;
    disp_un->extent.y =DISP_H;
    disp_vl->topLeft.x=DISP_X + DISP_OP_W;
    disp_vl->topLeft.y=DISP_Y;
    disp_vl->extent.x =DISP_W - DISP_OP_W - DISP_UN_W - 4;
    disp_vl->extent.y =DISP_H;
    disp_ns->topLeft.x=DISP_X + DISP_OP_W;
    disp_ns->topLeft.y=DISP_SUB_Y;
    disp_ns->extent.x =DISP_NS_W;
    disp_ns->extent.y =DISP_SUB_H;
    disp_fr->topLeft.x=DISP_X-DISP_BD;
    disp_fr->topLeft.y=DISP_SUB_Y-DISP_BD;
    disp_fr->extent.x =DISP_W+2*DISP_BD;
    disp_fr->extent.y =DISP_H+DISP_SUB_H+3*DISP_BD;*/

    Coord bd=2;
    Coord dp_x=8, dp_y=8, dp_w=WID-2*8, dp_h=28;
    Coord dp_main_h=16;
    Coord dp_sub_h=10;
    Coord op_w=16, un_w=40;

    /* initialize display constants */
    disp_fr->topLeft.x=dp_x-bd;
    disp_fr->topLeft.y=dp_y-bd;
    disp_fr->extent.x =dp_w+2*bd;
    disp_fr->extent.y =dp_h+2*bd;
    disp_ns->topLeft.x=dp_x+op_w;
    disp_ns->topLeft.y=dp_y;
    disp_ns->extent.x =24;
    disp_ns->extent.y =dp_sub_h;
    disp_mk->extent.x =48;
    disp_mk->extent.y =dp_sub_h;
    disp_mk->topLeft.x=dp_x+dp_w-disp_mk->extent.x;
    disp_mk->topLeft.y=dp_y;
    disp_op->topLeft.x=dp_x;
    disp_op->topLeft.y=dp_y+dp_h-dp_main_h;
    disp_op->extent.x =op_w;
    disp_op->extent.y =dp_main_h;
    disp_vl->topLeft.x=dp_x+op_w;
    disp_vl->topLeft.y=disp_op->topLeft.y;
    disp_vl->extent.x =dp_w-op_w-un_w;
    disp_vl->extent.y =dp_main_h;
    disp_un->topLeft.x=dp_x+dp_w-un_w;
    disp_un->topLeft.y=disp_op->topLeft.y;
    disp_un->extent.x =un_w;
    disp_un->extent.y =dp_main_h;

}

void InitializeFonts(FontID* font_l, FontID* font_s)
{
    (*font_l)=DISP_LARGE_FONT;
    (*font_s)=DISP_SMALL_FONT;
}

void InitializeUIConstants(void)
{
    InitializeDispConstants(&disp_vl, &disp_op, &disp_un,
                            &disp_ns, &disp_mk, &disp_fr);
    InitializeFonts(&disp_l_font, &disp_s_font);
}

/* util for popup */

UInt16 GetSelectedUnit(void)
{
    Int16 ret;
    FormPtr frm;
    ListPtr lp;

    frm=FrmGetFormPtr(PrefCurrentForm());
//    frm=FrmGetActiveForm();
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_LIST_UNIT));

    ret=LstGetSelection(lp)+1;
    if(ret<1) ret=1;
    return ret;
}

UInt16 GetSelectedUnitSystem(void)
{
    Int16 ret;
    FormPtr frm;
    ListPtr lp;

    frm=FrmGetFormPtr(PrefCurrentForm());
//    frm=FrmGetActiveForm();
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_LIST_USYS));

    ret=LstGetSelection(lp)+1;
    if(ret<1) ret=1;
    return ret;
}

void DrawUnitList(Int16 num,
                  RectangleType* rect,
                  Char** texts)
{
    UInt16 usys;
    Char str[MAX_NAME_CHAR];

    CALLBACK_PROLOGUE

    usys=GetSelectedUnitSystem();
    GetUnitName(usys, num+1, str);
    WinDrawChars(str, StrLen(str),
                 rect->topLeft.x, rect->topLeft.y);

    CALLBACK_EPILOGUE
}

void DrawUnitSystemList(Int16 num,
                        RectangleType* rect,
                        Char** texts)
{
    Char str[MAX_NAME_CHAR];

    CALLBACK_PROLOGUE

    GetUnitName(0, num+1, str);
    WinDrawChars(str, StrLen(str),
                 rect->topLeft.x, rect->topLeft.y);

    CALLBACK_EPILOGUE
}

void SetUnitList(UInt16 usys)
{
    UInt16 num;
    Char* str;
    FormPtr frm;
    ListPtr lp;
    ControlPtr cp;
    ListDrawDataFuncPtr drawF;

    frm=FrmGetFormPtr(PrefCurrentForm());
//    frm=FrmGetActiveForm();

    if(usys){
//        usys=GetSelectedUnitSystem();
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_LIST_UNIT));
        cp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_POPUP_UNIT));
        drawF=(ListDrawDataFuncPtr)DrawUnitList;
        str=pop_un;
    }else{
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_LIST_USYS));
        cp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_POPUP_USYS));
        drawF=(ListDrawDataFuncPtr)DrawUnitSystemList;
        str=pop_us;
    }
    num=GetUnitSystemNum(usys);
    LstSetListChoices(lp, NULL, num);
    LstSetDrawFunction(lp, drawF);
    if(MAX_LIST+2<num) num=MAX_LIST;
    LstSetHeight(lp, num);
    GetUnitName(usys, 1, str);
    LstSetSelection(lp, 0);
    CtlSetLabel(cp, str);
    if(!usys) SetUnitList(1);
}

void SetUnitListLabel(UInt16 usys, Int16 num, ListPtr lp, ControlPtr cp)
{
    Char* str;

    if(usys==0){
        str=pop_us;
    }else{
        str=pop_un;
    }
    GetUnitName(usys, num+1, str);
    LstSetSelection(lp, num);
    CtlSetLabel(cp, str);
}




/* DrawWindow */

void DrawValue(ValueStruct* vp)
{
    FontID old;
    Int16 wid, hgt;
    UInt16 nstr;
    Char str[MAX_CHAR];

    StrCopy(str, vp->str);
    nstr=vp->nstr;
    if(IsToBeThSeparated(vp)){
        ThSeparateNumber(str);
        nstr=StrLen(str);
    }else if(IsToBeBitSeparated(vp)){
        BitSeparateNumber(str);
        nstr=StrLen(str);
    }
//    disp_font=disp_l_font;  <- set default font at DrawWindowMain()
    old=FntSetFont(disp_font);
    wid=FntCharsWidth(str, nstr);
    if(disp_vl.extent.x<=wid){
        disp_font=disp_s_font;
        FntSetFont(disp_font);
        wid=FntCharsWidth(str, nstr);
        if(disp_vl.extent.x<=wid){
            StrCopy(str, "(over chars)");
            nstr=StrLen(str);
            wid=FntCharsWidth(str, nstr);
        }
    }
    hgt=FontHeight(disp_font);
    WinEraseRectangle(&disp_vl, 0);
    WinDrawChars(str, nstr,
                 disp_vl.topLeft.x+disp_vl.extent.x-wid,
                 disp_vl.topLeft.y+disp_vl.extent.y-hgt);
    FntSetFont(old);
}

void DrawOperator(void)
{
    FontID old;
    Char str[2];

    WinEraseRectangle(&disp_op, 0);
    if(!op_st.op) return;
    str[0]=op_st.op;  str[1]='\0';
    old=FntSetFont(DISP_LARGE_FONT);
    WinDrawChars(str, 1, disp_op.topLeft.x+4, disp_op.topLeft.y);
    FntSetFont(old);
}

void DrawMarks(void)
{
    FontID old;
    Char str[2]="-\0";
    Coord mk_x=disp_mk.topLeft.x+disp_mk.extent.x;

    WinEraseRectangle(&disp_mk, 0);
    old=FntSetFont(MK_FONT);
    mk_x-=15;
    if(op_st.fx){
        FntSetFont(symbolFont);
        str[0]='\x16';
        WinDrawChars(str, 1, mk_x, disp_mk.topLeft.y);
        FntSetFont(MK_FONT);
    }
    mk_x-=12;
    if(op_st.mm){
        str[0]='M';
        WinDrawChars(str, 1, mk_x, disp_mk.topLeft.y);
    }
    FntSetFont(old);
}

void DrawNumSys(ValueStruct* vp)
{
    FontID old;
    Char str[MAX_NAME_CHAR];
    UInt16 nstr;

    WinEraseRectangle(&disp_ns, 0);
    nstr=NumSysToStr(str, vp->nsys);
    old=FntSetFont(SUB_FONT);
    WinDrawChars(str, nstr, disp_ns.topLeft.x,
                 disp_ns.topLeft.y);
    FntSetFont(old);
}

void SetPushBtn(ValueStruct* vp)
{
    UInt16 nsys, id;
    FormPtr frm;

    nsys=vp->nsys;
    id=NumsysToPushBtnID(nsys);
    frm=FrmGetFormPtr(PrefCurrentForm());
//    frm=FrmGetActiveForm();
    if(id) FrmSetControlGroupSelection(frm, ID_PSBTN_NSYS_GROUP, id);
}

void DrawUnit(ValueStruct* vp)
{
    Int16 hgt;
    FontID old;
    Char str[MAX_SIGN_CHAR];

    WinEraseRectangle(&disp_un, 0);
    GetUnitSign(vp->usys, vp->unit, str);
    old=FntSetFont(disp_font);
    hgt=FontHeight(disp_font);
    WinDrawTruncChars(str, StrLen(str), disp_un.topLeft.x+4,
                      disp_un.topLeft.y+disp_un.extent.y-hgt,
                      disp_un.extent.x-2);
    FntSetFont(old);
}

void SetPopup(ValueStruct* vp)
{
    UInt16 usys;
    FormPtr frm;
    ListPtr lp;
    ControlPtr cp;
    ValueStruct tmp;

    frm=FrmGetFormPtr(PrefCurrentForm());
//    frm=FrmGetActiveForm();
    tmp.usys=vp->usys;
    tmp.unit=vp->unit;
    usys=GetSelectedUnitSystem();
    if(usys!=tmp.usys){
        lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_LIST_USYS));
        cp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_POPUP_USYS));
        GetUnitName(0, tmp.usys, pop_us);
        LstSetSelection(lp, tmp.usys-1);
        CtlSetLabel(cp, pop_us);
        SetUnitList(tmp.usys);
    }
    lp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_LIST_UNIT));
    cp=FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, ID_POPUP_UNIT));
    GetUnitName(tmp.usys, tmp.unit, pop_un);
    LstSetSelection(lp, tmp.unit-1);
    CtlSetLabel(cp, pop_un);
}


void DrawDisplayFrame(void)
{
    WinDrawRectangleFrame(simple3DFrame, &disp_fr);
/*    WinDrawLine(disp_ns.topLeft.x, disp_ns.topLeft.y+disp_ns.extent.y+DISP_BD,
                disp_ns.topLeft.x+disp_ns.extent.x, disp_ns.topLeft.y+disp_ns.extent.y+DISP_BD);
    WinDrawLine(disp_ns.topLeft.x, disp_ns.topLeft.y+disp_ns.extent.y+DISP_BD+1,
                disp_ns.topLeft.x+disp_ns.extent.x, disp_ns.topLeft.y+disp_ns.extent.y+DISP_BD+1);*/
}

void DrawWindowMain(ValueStruct* vp)
{
    FontID old;
    Int16 wid;
    Char str[MAX_SIGN_CHAR];

    // check unit char is too long
    disp_font=disp_l_font;
    GetUnitSign(vp->usys, vp->unit, str);
    old=FntSetFont(disp_font);
    wid=FntCharsWidth(str, StrLen(str));
    if(disp_un.extent.x<=wid){
        disp_font=disp_s_font;
        FntSetFont(disp_font);
    }
    if(update.vl){
        DrawValue(vp);
        update.vl=False;
    }
    if(update.un){
        DrawUnit(vp);
        update.un=False;
    }
    FntSetFont(old);

    if(update.op){
        // for casio patent
//        DrawOperator();
        update.op=False;
    }
    if(update.mk){
        DrawMarks();
        update.mk=False;
    }
    if(update.ns){
        DrawNumSys(vp);
        update.ns=False;
    }
    if(update.pb){
        SetPushBtn(vp);
        update.pb=False;
    }
    if(update.pp){
        SetPopup(vp);
        update.pp=False;
    }
    if(update.fr){
        DrawDisplayFrame();
        update.fr=False;
    }
}

void SetUpdateValue(void)
{
    update.vl=True;
    update.un=True;
}
void SetUpdateOperator(void)
{
    update.op=True;
}
void SetUpdateMarks(void)
{
    update.mk=True;
}
void SetUpdateNumSys(void)
{
    update.ns=True;
}
void SetUpdatePushBtn(void)
{
    update.pb=True;
}
void SetUpdateUnit(void)
{
    update.vl=True;
    update.un=True;
}
void SetUpdatePopup(void)
{
    update.pp=True;
}
void SetUpdateFrame(void)
{
    update.fr=True;
}

void SetUpdateFlags(void)
{
    update.vl=True;
    update.op=True;
    update.mk=True;
    update.ns=True;
    update.pb=True;
    update.un=True;
    update.pp=True;
}
