#include "mxcl.h"
#include "mxcl_id.h"



/*#define Rand_S            1
#define Rand_A     48828125
#define Rand_Max 4294967296
UInt32  Rand_X=Rand_S;*/



/* local prototypes */

extern int CharToNum(Char);
extern Char NumToChar(int);
extern void TrimRZero(Char*);
extern void TrimLZero(Char*);
extern Boolean StrToValBasedInt(int, Char*, FlpCompDouble*);
extern Boolean StrToValTime(Char*, FlpCompDouble*);
extern void ValInfToStr(FlpCompDouble, Char*);
extern void ValFloatToNonEStr(FlpCompDouble, Char*);
extern void ValBinToStr(FlpCompDouble, Char*);
extern void ValOctToStr(FlpCompDouble, Char*);
extern void ValHexToStr(FlpCompDouble, Char*);
extern void ValBasedIntToStr(int, FlpCompDouble, Char*);
extern void ValTimeToStr(FlpCompDouble, Char*);


/* util for codes */

UInt16 PushBtnIDToFormID(UInt16 id)
{
    switch(id){
      case ID_PSBTN_STD:
        return ID_FORM_STD;
      case ID_PSBTN_EXP:
        return ID_FORM_EXP;
      default:
        return 0;
    }
}

UInt16 FormIDToPushBtnID(UInt16 id)
{
    switch(id){
      case ID_FORM_STD:
        return ID_PSBTN_STD;
      case ID_FORM_EXP:
        return ID_PSBTN_EXP;
      default:
        return 0;
    }
}

UInt16 PushBtnIDToNumsys(UInt16 id)
{
    switch(id){
      case ID_PSBTN_FL:
        return NUM_FLOAT;
        break;
      case ID_PSBTN_BN:
        return NUM_BIN;
        break;
      case ID_PSBTN_OC:
        return NUM_OCT;
        break;
      case ID_PSBTN_HX:
        return NUM_HEX;
        break;
      case ID_PSBTN_TM:
        return NUM_TIME;
        break;
    }
    return 0;
}

UInt16 NumsysToPushBtnID(UInt16 nsys)
{
    switch(nsys){
      case NUM_FLOAT:
        return ID_PSBTN_FL;
        break;
      case NUM_BIN:
        return ID_PSBTN_BN;
        break;
      case NUM_OCT:
        return ID_PSBTN_OC;
        break;
      case NUM_HEX:
        return ID_PSBTN_HX;
        break;
      case NUM_TIME:
        return ID_PSBTN_TM;
        break;
    }
    return 0;
}

WChar ButtonIDToChar(UInt16 id)
{
    WChar ch=0;

    if(ID_BTN_0<=id && id<=ID_BTN_9){
        ch='0'+id-ID_BTN_0;
/*    }else if(ID_BTN_A<=id && id<=ID_BTN_F){
        ch='A'+id-ID_BTN_A;*/
    }else{
        switch(id){
          case ID_BTN_BS:
            ch='\b';
            break;
          case ID_BTN_PRD:
            ch='.';
            break;
          case ID_BTN_CLN:
            ch=':';
            break;
          case ID_BTN_CMM:
            ch=',';
            break;
          case ID_BTN_PLS:
            ch='+';
            break;
          case ID_BTN_MNS:
            ch='-';
            break;
          case ID_BTN_AST:
            ch='*';
            break;
          case ID_BTN_SLS:
            ch='/';
            break;
          case ID_BTN_PCT:
            ch='%';
            break;
          case ID_BTN_EQL:
            ch='=';
            break;
          default:
        }
    }
    return ch;
}

WChar MemBtnIDToChar(UInt16 id)
{
    WChar ch='0';

    switch(id){
      case ID_BTN_MP:
        ch='+';
        break;
      case ID_BTN_MM:
        ch='-';
        break;
      default:
    }
    return ch;
}

UInt16 CharToNumsys(Char ch, UInt16 nsys)
{
    if(ch==':'){
        if(nsys==NUM_TIME) return 0;
        return NUM_TIME;
    }else if(ch=='.'){
        if(nsys==NUM_TIME || nsys==NUM_TIME) return 0;
        return NUM_FLOAT;
    }else if('a'<=ch && ch<='f'){
        if(nsys==NUM_HEX) return 0;
        return NUM_HEX;
    }else if('A'<=ch && ch<='F'){
        if(nsys==NUM_HEX) return 0;
        return NUM_HEX;
    }else if('8'<=ch && ch<='9'){
        if(nsys!=NUM_OCT && nsys!=NUM_BIN) return 0;
        return NUM_FLOAT;
    }else if('2'<=ch && ch<='7'){
        if(nsys!=NUM_BIN) return 0;
        return NUM_FLOAT;
    }
    return 0;
}

UInt16 NumSysToStr(Char* str, UInt16 ns)
{
    UInt16 ret;

    switch(ns){
      case NUM_INF:
        StrCopy(str, "inf");
        break;
/*      case NUM_INT:
        StrCopy(str, "int");
        break;*/
      case NUM_BIN:
        StrCopy(str, "bin");
        break;
      case NUM_OCT:
        StrCopy(str, "oct");
        break;
      case NUM_HEX:
        StrCopy(str, "hex");
        break;
      case NUM_FLOAT:
        StrCopy(str, "float");
        break;
      case NUM_TIME:
        StrCopy(str, "time");
        break;
      default:
        str[0]='\0';
    }
    ret=StrLen(str);
    return ret;
}


/* util for checking */

Boolean IsAddChar(WChar ch)
{
    if(TxtCharIsDigit(ch)) return True;
    if('a'<=ch && ch<='f') return True;
    if('A'<=ch && ch<='F') return True;
    switch(ch){
      case '.':
      case ':':
      case ',':
        return True;
        break;
    }
    return False;
}

/*
Boolean IsOperatorDouble(WChar op)
{
    switch(op){
      case '=':
      case '+':
      case '-':
      case '*':
      case '/':
        return True;
      default:
        return False;
    }
    return False;
}
Boolean IsOperatorDoubleBtn(UInt16 op)
{
    switch(op){
      case ID_BTN_MOD:
        return True;
      default:
        return False;
    }
    return False;
}*/



/*Boolean IsFloat(ValueStruct v)
{
    switch(v.nsys){
      case NUM_FLOAT:
      case NUM_TIME:
        return True;
        break;
      default:
        return False;
    }
}*/

Boolean IsToBeThSeparated(ValueStruct* vp)
{
    if(vp->nsys==NUM_FLOAT && vp->nvec==1) return True;
    return False;
}

Boolean IsToBeBitSeparated(ValueStruct* vp)
{
    switch(vp->nsys){
      case NUM_BIN:
      case NUM_OCT:
      case NUM_HEX:
        return True;
        break;
      default:
        return False;
    }
}

/* util for string operations */

Boolean ParseNoError(Char* str, UInt16 nstr, UInt16 nsys)
{
    int i=nstr-1;
    while(i){
        if('0'<=str[i] && str[i]<='1'){
        }else if(str[i]==':'){
            if(nsys!=NUM_TIME) return False;
        }else if(str[i]=='.'){
            if(nsys!=NUM_FLOAT && nsys!=NUM_TIME) return False;
        }else if('a'<=str[i] && str[i]<='f'){
            if(nsys!=NUM_HEX) return False;
        }else if('A'<=str[i] && str[i]<='F'){
            if(nsys!=NUM_HEX) return False;
        }else if('8'<=str[i] && str[i]<='9'){
            if(nsys==NUM_OCT || nsys==NUM_BIN) return False;
        }else if('2'<=str[i] && str[i]<='7'){
            if(nsys==NUM_BIN) return False;
/*        }else if(str[i]=='-' && i!=0){
            return False;*/
        }
        i--;
    }
    return True;
}

void ChopZero(ValueStruct* vp, WChar ch)
{
    if(vp->str[0]=='0' && vp->str[1]=='\0'
       && ch!=PrefDecimalSeparator() && ch!=':' && ch!=','){
        vp->str[0]='\0';
        vp->nstr--;
    }
}


void ThSeparateNumber(Char* str)
{
    UInt16 i, j, n;
    Char tmp[MAX_CHAR+10];

    i=0;
    while(str[i]!='\0'){
        if(str[i]==PrefDecimalSeparator()) break;
        i++;
    }
    n=i;
    while(3<i) i-=3;
    StrNCopy(tmp, str, i);
    j=i;
    while(i<n){
        if(TxtCharIsDigit(str[i-1])){
            tmp[j]=PrefThousandSeparator();
            j++;
        }
        StrNCopy(tmp+j, str+i, 3);
        i+=3;  j+=3;
    }
    StrCopy(tmp+j, str+i);
    tmp[MAX_CHAR-1]='\0';
    StrCopy(str, tmp);
}

void BitSeparateNumber(Char* str)
{
    UInt16 i, j, n;
    Char tmp[MAX_CHAR+10];

    i=0;
    n=StrLen(str);
    while(4<n) n-=4;
    if(PrefZeroPadding()){
        for(i=0; i<4-n; i++) tmp[i]='0';
    }
    j=0;
    while(str[j]!='\0'){
        if(n==0){
            tmp[i]=' ';
            i++;
            n=4;
        }
        tmp[i]=str[j];
        n--;
        i++;  j++;
    }
    if(i<MAX_CHAR){
        tmp[i]='\0';
    }else{
        tmp[MAX_CHAR-1]='\0';
    }
    StrCopy(str, tmp);
}


/* val <-> str conversion */

int CharToNum(Char ch)
{
    int ret=0;

    if(TxtCharIsDigit(ch)){
        ret=ch-'0';
    }else if('a'<=ch && ch<='f'){
        ret=ch-'a'+10;
    }else if('A'<=ch && ch<='F'){
        ret=ch-'A'+10;
    }
    return ret;
}
Char NumToChar(int n)
{
    int ret='x';

    if(0<=n && n<=9){
        ret='0'+n;
    }else if(10<=n && n<=15){
        ret='A'+n-10;
    }
    return ret;
}
void TrimRZero(Char* str)
{
    int i, j=0;
    Boolean dc=False;

    for(i=0; i<StrLen(str); i++){
        if(str[i]==PrefDecimalSeparator()) dc=True;
        if(str[i]=='e' || str[i]=='E') break;
    }
    if(!dc) return;
    for(; str[i-1]=='0'; i--) j++;
    if(str[i-1]==PrefDecimalSeparator()){
        j--;  i++;
    }
    if(!j) return;
    for(; str[i+j]!='\0'; i++) str[i]=str[i+j];
    str[i]='\0';
}
void TrimLZero(Char* str)
{
    int i, j;

    for(i=0; str[i]!='\0'; i++){
        if(str[i]!='0') break;
    }
    if(i==0) return;
    j=0;
    for(; str[i]!='\0'; i++){
        str[j]=str[i];  j++;
    }
    if(j==0){
        str[j]='0';  j++;
    }
    str[j]='\0';
}

Boolean StrToValBasedInt(int base, Char* str, FlpCompDouble* v)
{
    Boolean ret=False;
    int sg=1, i;
    UInt16 nbit;
    UInt32 ival=0;

    if(base==2){
        nbit=1;
    }else if(base==8){
        nbit=3;
    }else if(base==16){
        nbit=4;
    }else{
        return ret;
    }
    i=0;
    if(str[i]=='-'){
        sg=-1;  i++;
    }
    for(; str[i]!='\0'; i++){
        ival=ival<<nbit;
        ival+=CharToNum(str[i]);
    }
    if(sg==-1) ival=~ival+1;
    if(PrefUBit()){
        v->d=ival;
    }else{
        v->d=(Int32)ival;
    }
    ret=True;
    return ret;
}

/*Boolean StrToValBasedInt(int base, Char* str, FlpCompDouble* v)
{
    Boolean ret=False;
    int sg=1, i;
    UInt16 nstr;
    double val=0.0, tmp=1.0;

    nstr=StrLen(str);
    for(i=nstr-1; 0<i; i--){
        val+=CharToNum(str[i])*tmp;
        tmp*=base;
    }
    if(str[i]=='-'){
        sg=-1;
    }else{
        val+=CharToNum(str[i])*tmp;
        tmp*=base;
    }
    val*=sg;
    v->d=val;
    ret=True;
    return ret;
}*/

Boolean StrToValTime(Char* str, FlpCompDouble* v)
{
    int sg=1, i, j;
    double val=0.0;
    FlpCompDouble dtmp;
    Char stmp[MAX_CHAR];

    i=0;  j=0;
    if(str[i]=='-'){
        sg=-1;  i++;
    }
    // hours
    while(str[i]!='\0'){
        if(str[i]==':'){
            i++;
            break;
        }
        stmp[j]=str[i];
        i++;  j++;
    }
    stmp[j]='\0';
    FlpBufferAToF(&(dtmp.fd), stmp);
    val+=60.0*60.0*dtmp.d;
    // munites
    j=0;
    while(str[i]!='\0'){
        if(str[i]==':'){
            i++;
            break;
        }
        stmp[j]=str[i];
        i++;  j++;
    }
    stmp[j]='\0';
    FlpBufferAToF(&(dtmp.fd), stmp);
    val+=60.0*dtmp.d;
    // seconds
    FlpBufferAToF(&(dtmp.fd), str+i);
    val+=dtmp.d;
    val*=sg;
    v->d=val;
    return True;
}


void ValInfToStr(FlpCompDouble v, Char* str)
{
    if(v.d>0){
        StrCopy(str, STR_INF);
    }else if(v.d<0){
        StrCopy(str, STR_MINF);
    }else{
        StrCopy(str, STR_NaN);
    }
}

void ValFloatToNonEStr(FlpCompDouble v, Char* str)
{
    int i, j;
    UInt32 mt;
    Int16 ex, sg;
    Char stmp[MAX_CHAR];

    if(FlpIsZero(v)){
        str[0]='0';  str[1]='\0';
        return;
    }
    FlpBase10Info(v.fd, &mt, &ex, &sg);
//        StrPrintF(debug_msg, "%ld %d %d", mt, ex, sg);
//    FrmCustomAlert(ID_DEBUGALERT, debug_msg, "", "");
    StrIToA(str, (Int32)(mt));
    i=StrLen(str);
    if(ex<0){
        i--;  j=0;
        while(ex<0){
            if(i<0){
                stmp[j]='0';
                j++;
            }else if(j==0 && str[i]=='0'){
                str[i]='\0';
            }else{
                stmp[j]=str[i];
                j++;
            }
            i--;
            ex++;
        }
        if(j){
            stmp[j]=PrefDecimalSeparator();
            j++;
            if(i>=0){
                while(i>=0){
                    stmp[j]=str[i];
                    j++;
                    i--;
                }
                j--;
            }else{
                stmp[j]='0';
            }
            i=0;
            if(sg==1){
                str[i]='-';
                i++;
            }
            while(j>=0){
                str[i]=stmp[j];
                i++;  j--;
            }
            str[i]='\0';
        }else{
            if(sg==1){
                stmp[0]='-';
                StrCopy(stmp+1, str);
                StrCopy(str, stmp);
            }
        }
    }else{
        while(ex){
            str[i]='0';
            i++;  ex--;
        }
        str[i]='\0';
        if(sg==1){
            stmp[0]='-';
            StrCopy(stmp+1, str);
            StrCopy(str, stmp);
        }
    }
}

void ValFloatToStr(RoundType rd, FlpCompDouble v, Char* str)
{
    FlpCompDouble vt;
    double dmin, dmax;

    if(FlpIsZero(v)){
        str[0]='0';  str[1]='\0';
        return;
    }
    if(rd.disp==RD_DISP) RoundValue(rd, &v);
    vt=v;
    FlpSetPositive(vt);
    PrefDMinMax(&dmin, &dmax);
    if(dmin<vt.d && vt.d<dmax){
        ValFloatToNonEStr(v, str);
    }else{
        FlpFToA(v.fd, str);
        TrimRZero(str);
    }
}

void ValBinToStr(FlpCompDouble v, Char* str)
{
    int i, j;
    UInt32 ival;
    Char tmp[33];

    tmp[32]='\0';
    if(PrefUBit()){
        ival=v.d;
    }else{
        ival=(Int32)v.d;
    }
    for(i=0; i<32; i++){
        tmp[i]='0'+(int)(ival&0x01);
        ival=ival>>1;
    }
    i--;
    if(!PrefZeroPadding()){
        while(i){
            if(tmp[i]!='0') break;
            i--;
        }
    }
//    if(MAX_CHAR<=i) i=MAX_CHAR-1;
    if(16<=i) i=15;
    j=0;
    for(; 0<=i; i--){
        str[j]=tmp[i];  j++;
    }
    str[j]='\0';
}

void ValOctToStr(FlpCompDouble v, Char* str)
{
    int i, j;
    UInt32 ival;
    Char tmp[13];

    tmp[12]='\0';
    if(PrefUBit()){
        ival=v.d;
    }else{
        ival=(Int32)v.d;
    }
    for(i=0; i<12; i++){
        tmp[i]='0'+(int)(ival&0x07);
        ival=ival>>3;
    }
    i--;
    if(!PrefZeroPadding()){
        while(i){
            if(tmp[i]!='0') break;
            i--;
        }
    }
//    if(MAX_CHAR<=i) i=MAX_CHAR-1;
//    if(16<=i) i=15;
    j=0;
    for(; 0<=i; i--){
        str[j]=tmp[i];  j++;
    }
    str[j]='\0';
}

/*void ValOctToStr(FlpCompDouble v, Char* str)
{
    Int32 ival;

    ival=v.d;
    StrPrintF(str, "%o", ival);
    if(!PrefZeroPadding()) TrimLZero(str);
}*/

void ValHexToStr(FlpCompDouble v, Char* str)
{
    UInt32 ival;

    if(PrefUBit()){
        ival=v.d;
    }else{
        ival=(Int32)v.d;
    }
    StrPrintF(str, "%lX", ival);
    if(!PrefZeroPadding()) TrimLZero(str);
}


void ValBasedIntToStr(int base, FlpCompDouble v, Char* str)
{
    int sg=1, i, j;
    long ival, div;
    int mod;
    Char stmp[MAX_CHAR];

    if(FlpGetSign(v)!=0){
        sg=-1;
        FlpSetPositive(v);
    }
    ival=v.d;
    j=0;
    while(ival){
        div=ival/base;
        mod=ival-base*div;
        stmp[j]=NumToChar(mod);
        j++;
        if(MAX_CHAR-1<=j) break;
        ival=div;
    }
    j--;
    i=0;
    if(sg==-1){
        str[i]='-';  i++;
    }
    while(j>=0){
        str[i]=stmp[j];
        i++;  j--;
    }
    if(i==0){
        str[i]='0';
        i++;
    }
    str[i]='\0';
}

void ValTimeToStr(FlpCompDouble v, Char* str)
{
    long div;
    double val, mod;
    FlpCompDouble vt;

    if(FlpGetSign(v)!=0){
        str[0]='-';  str++;
        FlpSetPositive(v);
    }
    // hours
    val=v.d;
    div=val/3600;
    mod=val-3600.0*div;
    StrIToA(str, (Int32)(div));
    while(str[0]!='\0'){
        str++;
    }
    // munites
    str[0]=':';  str++;
    val=mod;
    div=val/60;
    mod=val-60*div;
    if(div<10){
        str[0]='0';  str++;
    }
    StrIToA(str, (Int32)(div));
    while(str[0]!='\0'){
        str++;
    }
    // seconds
    str[0]=':';  str++;
    if(mod<10.0){
        str[0]='0';  str++;
    }
    vt.d=mod;
    ValFloatToNonEStr(vt, str);
}




Boolean StrToVal(ValueStruct* vp)
{
    int i=0, j=0;
    Char* str[MAX_VEC];
    Boolean ret=False;

    if(!ParseNoError(vp->str, vp->nstr, vp->nsys)) return False;
    str[j]=vp->str;
    while(vp->str[i]!='\0'){
        if(vp->str[i]==','){
            vp->str[i]='\0';
            i++;  j++;
            if(vp->str[i]==' ') i++;
            str[j]=vp->str+i;
        }
        i++;
    }
    vp->nvec=j+1;

    ret=True;
    for(j=0; j<vp->nvec; j++){
        if(vp->nsys==NUM_FLOAT){
            FlpBufferAToF(&(vp->v[j].fd), str[j]);
        }else if(vp->nsys==NUM_BIN){
            ret=(ret && StrToValBasedInt(2.0, str[j], &(vp->v[j])));
        }else if(vp->nsys==NUM_OCT){
            ret=(ret && StrToValBasedInt(8.0, str[j], &(vp->v[j])));
        }else if(vp->nsys==NUM_HEX){
            ret=(ret && StrToValBasedInt(16.0, str[j], &(vp->v[j])));
        }else if(vp->nsys==NUM_TIME){
            ret=(ret && StrToValTime(str[j], &(vp->v[j])));
        }
    }
    if(ret) vp->fix=True;

/*    FlpBase10Info(vp->v.fd, &mt, &ex, &sg);
        StrPrintF(debug_msg, "%ld e %d %d %ld", mt, ex, sg);
            FrmCustomAlert(ID_DEBUGALERT, debug_msg, "", "");*/
/*        FlpFToA(vp->v.fd, debug_msg);
            FrmCustomAlert(ID_DEBUGALERT, debug_msg, "", "");*/
    return ret;
}

void ValToStr(ValueStruct* vp)
{
    int j, l;
    Char str[MAX_CHAR];
    RoundType rd;
    double dmin, dmax, old_dmin, old_dmax;

    vp->str[0]='\0';
    rd=PrefRoundType();
    PrefDMinMax(&dmin, &dmax);
    old_dmin=dmin;
    old_dmax=dmax;
    if(1<vp->nvec){
        VecRoundType(&rd);
        if(dmin<0.001) dmin=0.001;
        if(dmax>10000) dmax=10000;
    }
    PrefSetDMinMax(dmin, dmax);
    for(j=0; j<vp->nvec; j++){
        if(IsMathLibOpened() && !finite(vp->v[j].d)){
            if(isnan(vp->v[j].d)){
                StrCopy(str, STR_NaN);
            }else if(isinf(vp->v[j].d)>0){
                StrCopy(str, STR_INF);
            }else{
                StrCopy(str, STR_MINF);
            }
        }else if(vp->nsys==NUM_INF){
            ValInfToStr(vp->v[j], str);
        }else if(vp->nsys==NUM_BIN){
//            ValBasedIntToStr(2, vp->v[j], str);
            ValBinToStr(vp->v[j], str);
        }else if(vp->nsys==NUM_OCT){
//            ValBasedIntToStr(8, vp->v[j], str);
            ValOctToStr(vp->v[j], str);
        }else if(vp->nsys==NUM_HEX){
//            ValBasedIntToStr(16, vp->v[j], str);
            ValHexToStr(vp->v[j], str);
        }else if(vp->nsys==NUM_TIME){
            ValTimeToStr(vp->v[j], str);
        }else{
            ValFloatToStr(rd, vp->v[j], str);
        }
        l=StrLen(vp->str)+StrLen(str);
        if(MAX_CHAR<l) break;
        StrCat(vp->str, str);
        if(MAX_CHAR<l+2) break;
        if(j!=vp->nvec-1) StrCat(vp->str, ", ");
    }
    vp->nstr=StrLen(vp->str);
    PrefSetDMinMax(old_dmin, old_dmax);
}


